------------------------------------------------------
--                   MathTools.lua
------------------------------------------------------
MathTools={}

--取整
function MathTools.GetIntPart(x)
    if(x<=0) then
        return math.ceil(x)
    end
    local value = math.ceil(x)
    if(value==x) then
        return value
    else

        return value-1
    end
end

-- 保留小数点自定义位数 n不填就是只要整数  四舍五入
function MathTools.GetPreciseDecimal(num, n)
	if type(num) ~= "number" then
        return num;
    end

    n = n or 0;
    n = math.floor(n)
    local fmt = '%.' .. n .. 'f'
    --print("num = ".. num)
    --print("sub format"..string.format(fmt, num))

    

    
    local nRet = tonumber(string.format(fmt, num))
    return nRet;
end
-- 取小数点  非四舍五入
function MathTools.GetPreciseDecimalActual(nNum,n) 
    if type(nNum) ~= "number" then
         return nNum
    end
    if(nNum ==0) then
        return 0
    end
    n = n or 0;
    n = math.floor(n)
    if n < 0 then
        n = 0;
    end
    local nDecimal = 1/(10 ^ n)
    if nDecimal == 1 then
        nDecimal = nNum;
    end
    local nLeft = nNum % nDecimal;
    return nNum - nLeft;
end 

function MathTools.tonumber(value)
    return tonumber(value)
end

function MathTools.IsNumber(key)
    return LuaTools.IsNumber(key)
end
------------------------------------------------------
--                   TimeTools.lua
------------------------------------------------------
--时间相关工具类
TimeTools = {}
TimeTools.__index = TimeTools
local timeLabel = nil


--[[
os.time返回的是从1970年x月x日到现在经过的秒数
os.date返回的是按照一定格式输出的日期字符串或table。

java time 是毫秒
lua的os.time是秒
c# time 是java time * 10000

> print(os.time())
1337060663
> print(os.date())
05/15/12 13:44:30

]]

--传入结束时间戳返回剩余时间戳
function TimeTools.GetSurplusTime(endTime)
    local surplusTime = endTime - os.time ()
	--print("endTime"..endTime.."surplusTime"..surplusTime.."os.time ()"..os.time ())
    return surplusTime
end

--传入结束时间戳返回剩余时间的 时分秒格式 参数是java时间
function TimeTools.GetSurplusTimeOfSFM(endTime)
    
    return TimeTools.FormatTimeOfSFM(TimeTools.GetSurplusTime(endTime))
end

--格式化时间 时:分:秒 以00:00:00格式 获取 lua 下os.time
--只能返回以 1970 1 1 8:00:00格式的 如果参数是0 返回的就是这个时间  
--如果针入秒为单位的时间想返回hh:mm:ss请调用TimeTools.FormatTimeOfSecond
function TimeTools.FormatTimeOfSFM (time)
	--print("FormatTimeOfSFM"..time)
    return os.date("%H:%M:%S",time)
end


--格式化时间 时:分:秒 以00:00:00格式 获取 lua 下os.time
function TimeTools.FormatJavaTimeOfSFM (javatime)
	local time = TimeTools.JavaTimeToOSTime(javatime)
    return os.date("%H:%M:%S",time)
end

--格式化时间 时:分:秒 以00:00:00格式 获取 lua 下os.time
function TimeTools.FormatJavaTimeOfSF (javatime)
	local time = TimeTools.JavaTimeToOSTime(javatime)
    return os.date("%H:%M",time)
end

--格式化时间 时:分:秒 00:01:00
function TimeTools.FormatTimeOfSecond (timeNum)

	local _seconds = timeNum % 60

	local _minutes = (timeNum - _seconds)/60 % 60
	--_minutes = TimeTools.GetPreciseDecimal(_minutes, 0)

	local _hour = (timeNum -_seconds - _minutes*60) / 60 / 60 
	--_hour = TimeTools.GetPreciseDecimal(_hour, 0)
	
	
	local _time = string.format("%02d:%02d:%02d",_hour,_minutes,_seconds)
    return _time
end
--传入秒数  返回当前秒数转换成的时分秒
function  TimeTools.FormatTimeOfSurplusTime(timeNum)
	
	local _hour = timeNum / 60 / 60
	--print("_hour".._hour)
	_hour = math.floor(_hour)
	--print("_hour---------".._hour.."timeNum"..timeNum)
	local _minutes = (timeNum-(_hour*3600))/ 60
	_minutes = math.floor(_minutes)
	--	print("_minutes---------".._minutes)

	local _seconds = timeNum-(_hour*3600)-(_minutes*60)
	_seconds =   math.floor(_seconds)
	--	print("_seconds---------".._seconds)
	local _time = string.format("%02d:%02d:%02d",_hour,_minutes,_seconds)
    return _time
end 
--格式化时间 时:分
function TimeTools.FormatTimeOfSF (time)
    return os.date("%H:%M",time)
end

--格式化时间 年:月:日
function TimeTools.FormatTimeOfNYR (javatime)
	local time = TimeTools.JavaTimeToOSTime(javatime)
    return os.date ("%Y年%m月%d日", time)
end

--格式化时间 年-月-日
function TimeTools.FormatTimeOfNYRY_M_D (javatime)
	local time = TimeTools.JavaTimeToOSTime(javatime)
    return os.date ("%Y-%m-%d", time)
end

--格式化时间 月：日
function TimeTools.FormatTimeOfYR (javatime)
	local time = TimeTools.JavaTimeToOSTime(javatime)
    return os.date ("%m月%d日", time)
end

--格式化时间 年:月:日:时:分:秒
function TimeTools.FormatTimeOfNYRSFM (javatime)
	local time = TimeTools.JavaTimeToOSTime(javatime)
    return os.date ("%Y-%m-%d %H:%M:%S", time)
end
--格式化时间 月：日：时：分
function TimeTools.FormatTimeOfMDHM(javatime)
	local time = TimeTools.JavaTimeToOSTime(javatime)
    return os.date ("%m月%d日 %H:%M", time)
end

--格式化时间 年:月:日:时
function TimeTools.FormatTimeOfNYRS (javatime)
	local time = TimeTools.JavaTimeToOSTime(javatime)
    return os.date ("%Y年%m月%d日 %H点", time)
end

-- boolen to string
function TimeTools.BooleanToString(bool)
	str = bool and "真" or "假"
	return str
end

-- number to inter
function TimeTools.NubmerToInter(_number)
	local number = _number - 0
	if number <= 0 then
		return math.ceil(number)
	end
	if math.ceil(number) == number then
		return number
	else
		return math.ceil(number) - 1
	end
end


-- 保留小数点自定义位数
function TimeTools.GetPreciseDecimal(num, n)

	return UnityTools.GetPreciseDecimal(num,n)
end

function PrintTime ()
    print(os.date ("%H:%M:%S", os.time() ))
end

--将服务器的时间（string形式的毫秒单位)转成 秒单位
function TimeTools.ChangeServerTimeToSec(serverTime)
    return string.sub(serverTime, 0, string.len(serverTime) - 3)
end

--将服务器时间转成os.time时间
function TimeTools.JavaTimeToOSTime(javaTime)
	local javaToLuaTime = javaTime/1000
    --print("java to lua time is "..javaToLuaTime);
    javaToLuaTime = UnityTools.GetPreciseDecimal(javaToLuaTime)

	--local javaToLuaTime = (javaTime-javaTime%1000)/1000
	--logError("javaToLuaTime")
	--logError(javaTime)
	--logError(javaToLuaTime)
	return javaToLuaTime
end

--将服务器时间转成os.time时间
function TimeTools.OSTimeToJavaTime(osTime)
	local javaTime = osTime*1000
    --print("java to lua time is "..javaToLuaTime);
    
	return javaTime
end

--获得当前时间的时分秒
function TimeTools.GetCurTimeSFM()
	return TimeTools.FormatTimeOfSFM(os.time())
end

--获得当前时间
function TimeTools.GetCurTime()
	return os.time()
end
--return TimeTools


------------------------------------------------------
--                   JsonBuffer.lua
------------------------------------------------------
JsonBuffer={}

function JsonBuffer.New()
    local item = {}

    setmetatable(item,JsonBuffer)
    JsonBuffer.__index = JsonBuffer

    item.text=""
    item.content=""

    item.contentList={}


    --临时项
    item.tempContent=""
    return item
    
end


--添加一项 项是字符串
function JsonBuffer:AddItem(str)

    if(self.tempContent == nil) then
    
        self.tempContent =str
    else
        self.tempContent = self.tempContent ..",\r\n"
        self.tempContent = self.tempContent ..str
    end
end

function JsonBuffer:AddString(key,value)
    local str  ="\""..key.."\":\""..value.."\""
    self:AddItem(str)
end

--添加一项 项是字符串
function JsonBuffer:AddInt(key,value)

    local str = "\""..key.."\":"..value
    self:AddItem(str)
    
end

--创建一组
function JsonBuffer:CreateGroup()
    self.tempContent = nil
    

end

--结束一组
function JsonBuffer:EndGroup()

    
    self.tempContent = "{\r\n" ..self.tempContent.."\r\n}"

    

    table.insert(self.contentList,self.tempContent);
    self.tempContent = ""
end


--获得json最终内容
function JsonBuffer:GetJsonContent()
    local text = ""

    for i,v in ipairs(self.contentList) do
        text = text..v
        if(i<#self.contentList) then
            text =text..","
        end
        text= text.."\r\n"
    end

    return text
end


function JsonBuffer:GetAllJsonText()
    return self:GetJsonStruct(self:GetJsonContent())
end
--获得json结构
function JsonBuffer:GetJsonStruct(text)
    local sb = nil
    sb= "{\r\n";
    sb = sb..("\"RECORDS\":[\r\n");

    sb = sb..text;

    sb = sb.."]\r\n";
    sb = sb.."}"

    return sb
end



------------------------------------------------------
--                   JsonTools.lua
------------------------------------------------------
-- 读表工具
JsonTools = {}
JsonTools.buffer_ = {}


JsonTools.PRINT_FLAG = true or false;
-- 初始化所有json表
function JsonTools:InitJson ()
	--返回json的路径位置
	--logError("JsonStartTime"..Time.time)

    
    
    -- JsonTools:PrintJsonSta();

    local data = self:GetJson (JsonConstant.TB_Z_JSON_SYSTEM)
    local dataArray = data["RECORDS"]
    JsonManage:PutData (dataArray, "json number" .. table.maxn (dataArray), JsonConstant.TB_Z_JSON_SYSTEM)
    item = JsonManage:GetTableItemOfName (JsonConstant.TB_Z_JSON_SYSTEM)
--    print("共有" ..#item:GetJsonTable() .."个表")
    for	k, v in pairs (item:GetJsonTable ()) do
		--获得json的路径
        
		--传入路径 返回数据
        --logError("第"..k.."是"..v.jsonName)
        data = self:GetJson (v.jsonName)
        if(data~=nil) then
            dataArray = data["RECORDS"]

            --print("print  ".. v.jsonKey)
            JsonManage:PutData (dataArray, v.jsonKey, v.jsonName)
        end
		
--下面是一个读取 jsonKey的表 是有重复记录的 样子
--		---- if(v.jsonKey == "architecture_type") then
--			for k,v in pairs(dataArray) do
--				logError(k..":")
--				logError(v==nil);
--				for tk,tv in pairs(v) do
--					logError(tk..":"..tv)
--				end
--				
--			end
--			
--		end
		
    end

    --logError("JsonEndTime"..Time.time)
end

-- 传入路劲返回json数据
function JsonTools:GetJson (jsonName)
    --logError("读取Json：" .. jsonName)
    local path = self:GetJsonPath (jsonName)
    local text = nil

    --logError("JsonTools:GetJson".. path);
    --logError("appconst.updatemode")
    --logError(AppConst.UpdateMode)
    if(AppConst.UpdateMode == true) then
        file = io.open(path, "r")
        --logError("update模式 路线"..path)
     end
     if(file==nil ) then
        --logError("GetJsonPath 热更地址文件不存在" );
        --logError(jsonName)

        



        text = FileTools.LoadJsonToText(jsonName);


     else
        file:close()
        --logError("文件存在");
        --logError("util==nil")
        text = tools_CjsonUtil.file_load(path)
        --logError("读取完成")
        -- logError(text)
       
     end
    
    if(text == nil) then
        logError("表"..jsonName.."不存在 请检查JsonData是否存在")
        --logError("表"..jsonName.."不存在 请检查JsonData是否存在")
        --logError("表"..jsonName.."不存在 请检查JsonData是否存在")
        --logError("表"..jsonName.."不存在 请检查JsonData是否存在")

        --return nil
    end

    
  --  print(text)

    local obj = tools_Cjson.decode (text)
    return obj
end

--json path-data对象池
function JsonTools:GetBufferJson(path)
    -- 检查是否读过
    --print("GetBufferJson:"..path)
    if nil == JsonTools.buffer_[path] then
        --读取数据
        --local path_ = JsonTools:GetJsonPath(path)  
        --print("load json from file:"..path_)
		--TODO: 优化读json表方式，读表的时候设置好key
		local jsonTable = JsonTools:GetJson(path)
        JsonTools.buffer_[path] = jsonTable["RECORDS"]
    end
    return JsonTools.buffer_[path]
end


-- 传入表名返回路径拼接 获得热更地址
function JsonTools:GetJsonPath (jsonName)
    local path = '';

    path = Util.DataPath

    --logError("GetJson"..jsonName)

    --logError("path = "..path)

    if(UnityEngine.Application.isMobilePlatform == false and AppConst.Simulation_Phone == 0) then
        -- 如果是编辑器 且 不是模拟 可以返回 本地路径   注意 这里 Simulation_Phone 虽然是bool 但在这里只能用0 判断  而 isMobilePlatform 为什么可以用bool方式 是因为 他是一个属生 而不是 值
        --参见 UnityEngine_ApplicationWrap  的 L.RegVar("isMobilePlatform", get_isMobilePlatform, null); 而 AppConst的是 L.RegConstant("Simulation_Phone", 0);
        path = AppConst.FrameworkRoot
        -- logError(path)
        path = path .. "/"
         logError("从本地查找")
    end
	--print("path----------"..path)
--[[ 
    原代码 
    热更时 或是 移动平台时 从热列地址 DataPath返回  不热更 移动平台为什么可行呢？是因为之前会复制文件到热更地址，但同在不再复制文件了 所以不能这样了
    非热更时， 苹果因为从本地读 所以返回本地地址
            

    if(Util.IsIphone() and AppConst.UpdateMode == 0  ) then
        --logError("如果是苹果的话 先从内部读下")
        path = Util.AppContentPath()
    else
        if AppConst.UpdateMode == 1 or UnityEngine.Application.isMobilePlatform then        
            --logError("是热更状态 或是 移动状态")

            --如果是热更状态 或 打包状态 
            --返回 Util.DataPath 位置  数据存储的位置
            
            --这里 不能这样用 看看有没有别的判断吧 不是util 或者 先强制写成 iphone的 用于测试
            --util 是因为没保存上 明天再试一下 加下 isphone的方法
            --等一切都完事了 试试真正的热更 看是不是好的
            

                path = Util.DataPath
            
        else
            --logError("不是热更状态 也不是 移动状态")
            --本地luaframe /lua/jsondata的位置
            path = Util.AppContentPath()
        end
    end
]]
    
--    print(path .. "lua/JsonData/" .. jsonName .. ".json")
    return  path .. "lua/JsonData/" .. jsonName .. ".json"
end





--输出一下表名的内容
function JsonTools:PrintTable(jsonName)
    local jsonItem = JsonManage:GetTableItemOfName(jsonName)
    if(jsonItem == nil) then
        logError("表"..jsonName.."不存在")
    else
        logError("表"..jsonName.."存在")

        logError(jsonItem:GetJsonKey())

        local jsonList = jsonItem:GetJsonTable()

        for k,v in pairs(jsonList) do
            print("主键"..k)
            for k1,v1 in pairs(v) do
                print("     子项 字段"..k1.."值"..v1)
            end
        end
        

        --LuaPrintTools.PrintTable(jsonItem:GetJsonTable())
    end

end

function JsonTools:PrintJsonSta()
    local sb = StringBuffer.New()
    sb:Append("Json读取设置")

    if(AppConst.Simulation_Phone) then
        sb:Append("模拟手机")
    else
        sb:Append("非模拟手机")
    end
    if(UnityEngine.Application.isMobilePlatform) then
        sb:Append("手机")
    else
        sb:Append("非手机")
    end
    if(UnityEngine.Application.isMobilePlatform == false and AppConst.Simulation_Phone == 0) then
        sb:Append("当前不是 手机模式 也不是 模拟手机模式")
        sb:Append("通过JsonTools:GetJsonPath方法 从 AppConst.FrameworkRoot里读取 : " .. AppConst.FrameworkRoot)
    else
        sb:Append("当前是手机 或是模拟手机模式 从 Util.DataPath 读取 :" .. Util.DataPath)
    end
    local path = JsonTools:GetJsonPath("X的文件名")
    sb:Append("最终是"..path)
    if(AppConst.UpdateMode == true) then
        sb:Append("热更模式 先从path 读取")
    else
    end
    sb:Append("如未读取 准备从本地读取")
    logError(sb:GetMessageStr())
end

--return JsonTools


------------------------------------------------------
--                   ListTools.lua
------------------------------------------------------


ListTools={}

--返回list中是否有 以value为值的对象 
function ListTools.HasItem(list,value)
	for k,v in pairs(list) do
		if(v == value) then
			return true
			
		end
	end
	return false
end
------------------------------------------------------
--                   JsonConstant.lua
------------------------------------------------------
-- json常量表
JsonConstant =
{
    TB_Z_JSON_SYSTEM = "tb_z_json_system",
    TB_Z_HERO = "tb_z_hero",
    TB_Z_HERO_INITIAL_PROPERTY = "tb_z_hero_initial_property",
    TB_Z_ROLE = "tb_z_role",
    TB_Z_SYSTEM = "tb_z_system",
    TB_Z_CITY = "tb_z_city",
    TB_Z_CITY_CONNECTION = "tb_z_city_connection",
    TB_Z_HERO_GROWTH = "tb_z_hero_growth",
    TB_Z_PROPERTY_TRANSFER = "tb_z_property_transfer",
    TB_Z_HERO_PASSIVE = "tb_z_hero_passive",
    TB_Z_HERO_COMBO = "tb_z_hero_combo",
    TB_Z_HERO_SKILL = "tb_z_hero_skill",
	TB_Z_ERROR_SHOW = "tb_z_error_show",
	TB_Z_CITY_ARCHITECTURE = "tb_z_city_architecture",
    TB_Z_PROP_INFO = "tb_z_prop_info",
	TB_Z_HERO_EXPERIENCE = "tb_z_hero_experience",
	Tb_Z_HERO_ADVANCE = "tb_z_hero_advance",
	TB_Z_SOUL_RECOVER_COST = "tb_z_soul_recover_cost",
	TB_Z_HERO_AWAKEN = "tb_z_hero_awaken",
	TB_Z_HERO_AWAKEN_SKILL  = "tb_z_hero_awaken_skill",
    TB_Z_BUFF="tb_z_buff",
	TB_Z_SOLDIERS_TYPE = "tb_z_soldiers_type",
	TB_Z_USER_LV_UP_EXP_NEED = "tb_z_user_lv_up_exp_need",
	TB_Z_USER_WAR_AREA_CONFIG = "tb_z_war_area_config",
	TB_Z_USER_RANK_LEVEL_CONFIG="tb_z_user_rank_level_config",
	TB_Z_EQUIP = "tb_z_equip",
    TB_Z_STRATEGY_COOLING_TIME="tb_z_strategy_cooling_time",
	TB_Z_SHOP_INFO="tb_z_shop_info",
    TB_Z_SHOP_NPC_EXP="tb_z_shop_npc_exp",
	TB_Z_BLACK_SHOP_INFO = "tb_z_black_shop_info", 
	TB_Z_BLACK_SHOP_INTERIOR_INFO = "tb_z_black_shop_interior_info",
	TB_Z_ATTRIBUTE = "tb_z_attribute",
    TB_Z_MAIN_CITY = "tb_z_home_city_build_consumption",    --主城花费相关
    TB_Z_ANNOUNCEMENT = "tb_z_announcement",    --公告表
    TB_Z_FUNCTION_AREA = "tb_z_client_function_area",    --显示区域表
    TB_Z_FUNCTION_AREA_ITEM = "tb_z_client_function_area_item",    --显示区域包括哪些项
    TB_Z_FUNCTION_CONSTANT = "tb_z_client_function_constant",    --功能表
	TB_Z_PROP_PROPERTY = "tb_z_prop_property", --每个计策的价格
    TB_Z_CUSTOM_HERO_LIST = "tb_z_custom_hero_list",--排序问题
    TB_Z_EQUIP_POWER_UP_CONFIG = "tb_z_equip_power_up_config", --强化属性表
    TB_Z_EQUIP_SUITE_CONGIF =  "tb_z_equip_suite_config",   --套装属性
    TB_Z_HEAD =  "tb_z_head",   --头像属性
    TB_Z_FEATS = "tb_z_feats",--日常任务
    TB_Z_TASK_CONFIG = "tb_z_task_config", -- 战局任务
    TB_Z_REWARD_CONFIG = "tb_z_reward_config",-- 奖励字符串
    TB_Z_PROP_SEQUENCE = "tb_z_prop_sequence", --货币常量数据
    TB_Z_STATE = "tb_z_state", --州表
    TB_Z_STATE_EXCHANGE = "tb_z_state_exchange",--州奖励兑换表
    TB_Z_RANDOM_NAME = "tb_z_random_name", --随机名字表
    TB_Z_TREASURE_BOX = "tb_z_treasure_box", --宝箱表

    TB_Z_CLIENT_TALK="tb_z_client_channel_off_talk",--对话
    TB_Z_CLIENT_CHANNEL_BOTTOM="tb_z_client_channel_off_bottom",--引导时下方按钮功能
    TB_Z_CHANNEL_OFF = "tb_z_client_channel_off", -- 引导相关
    TB_Z_CLIENT_CHANNEL_OFF_TASK = "tb_z_client_channel_off_task",
    TB_Z_CITY_GUIDE = "tb_z_city_guide", --引导城池区域
    TB_Z_CLIENT_PREFAB_PATH = "tb_z_client_prefab_path", --预置物的路径表

    TB_Z_CLIENT_CHANNEL_OFF_CARTOON = "tb_z_client_channel_off_cartoon",--引导漫画
    TB_Z_CLIENT_CHANNEL_OFF_CARTOON_TALK = "tb_z_client_channel_off_cartoon_talk",--引导漫画对话
    TB_Z_CLIENT_CHANNEL_OFF_CARTOON_TEXTURE = "tb_z_client_channel_off_cartoon_texture",--引导漫画图片
    TB_Z_ACTIVITY_SYSTEM = "tb_z_activity_system",--精彩活动系统
    TB_Z_ACTIVITY_SIGN = "tb_z_activity_sign",  --精彩活动之 签到系统

    TB_Z_ACTIVITY_SEVEN_DAY="tb_z_activity_seven_day",--七天活动

    TB_Z_ACTIVITY_TITLE_CONTENT="tb_z_client_activity_title_content",--活动显示内容表
    TB_Z_RECHARFE_SYSTEM = "tb_z_recharge_system",  --充值表
    TB_Z_ACTIVITY_RECHARGE_REWARD = "tb_z_activity_recharge_reward",--累计充值

    TB_Z_ACTIVITY_INVITATION = "tb_z_activity_invitation",  --注册邀请活动数据


    TB_Z_ACTIVITY_SCORE_TASK = "tb_z_activity_active_score_task",  --周活跃任务
    TB_Z_ACTIVITY_SCORE_REWARD = "tb_z_activity_active_score_reward",  --周活跃奖励
    
    TB_Z_VIP_INFO = "tb_z_vip_info",--会员信息表


    TB_Z_FUNCTION_SWITCH = "tb_z_function_switch", --功能屏蔽

    TB_Z_BUBBLE_INFO = "tb_z_bubble_info",  -- 聊天气泡表

    TB_Z_INTEGRAL_SHOP = "tb_z_integral_shop", --周末活动兑换商店
    TB_Z_ACTIVITY_WEEKEND_SCORE_CONFIG = "tb_z_activity_weekend_score_config", --周末活动积分配置表
    TB_Z_CLINET_ACTIVITY_WEEKEND_DESC = "tb_z_client_activity_weekend_desc", --周末活动描述

    TB_Z_MAPID  = "tb_z_mapId" , --地图尺寸

    TB_Z_ACTIVITY_HOLIDAY_EXCHANGE="tb_z_activity_holiday_exchange",    --节日活动表
    TB_Z_ACTIVITY_HOLIDAY_DESC="tb_z_activity_holiday_desc",    --节日活动说明
    TB_Z_ACTIVITY_FUND_RANK_REWARD = "tb_z_activity_fund_rank_reward",  --官职基金投资
    TB_Z_SINGLE_RECHARGE = "tb_z_single_recharge",--单笔充值
    TB_Z_ACTIVITY_TURNTABLE_COFIG = "tb_z_activity_turntable_config",
    TB_Z_ACTIVITY_MYSTERIOUS_BOX = "tb_z_activity_mystic_box_reflush_config",--神秘宝箱
    TB_Z_ACTIVITY_MYSTERIOUS_BOX_KEY = "tb_z_activity_mystic_box_key_config",--神秘宝箱钥匙
    TB_Z_PROP_FRAGMENT_CONFIG = "tb_z_prop_fragment_config",--碎片合成表
    TB_Z_CLIENT_GAME_SETTING = "tb_z_client_game_setting",--游戏设置
    TB_Z_CLIENT_LOADING_CONTENT = "tb_z_client_loading_content",--切换场景说明
    TB_Z_CLIENT_SKILL_EFFECT_AUDIO = "tb_z_client_skill_effect_audio", --技能特效的名字
    TB_Z_STATE_INTEGRAL_SHOP = "tb_z_state_integral_shop",  --州积分兑换商店
    TB_Z_ACHIEVE = "tb_z_achieve",--成就
    TB_Z_ACHIEVE_SHEET = "tb_z_achieve_sheet",--成就页
    TB_Z_SAME_CLASS_TOP_PLAYER = "tb_z_activity_sameclass_top_player", --同期君主排行
    TB_Z_RANK_RECORD_PLAYER = "tb_z_activity_rankrecord_top_player", --全服玩家战绩排行榜
    TB_Z_CLIENT_HELP_DESC = "tb_z_client_help_desc",--帮助描述表 
    TB_Z_ACTIVITY_EVETYDAY_LOGIN_REWARD = "tb_z_activity_everyday_login_reward",  --内测登录表
    TB_Z_FUNCTION_LOCK = "tb_z_client_function_lock",--功能屏蔽开关
    TB_Z_PLATFORM = "tb_z_client_platform", --渠道表
    TB_Z_FAMILY_JOB_CONFIG = "tb_z_family_job_config", --家族职位表
    TB_Z_RED_PACKET_INFO = "tb_z_red_packet_info", --红包表
    TB_Z_CLIENT_BATTLE_BUFF_DESC="tb_z_client_battle_buff_desc",--技能状态表
    TB_Z_IGNORE_PROTOCOL_LIST = "tb_z_client_protocol_ignore_list",--忽略协议表
    TB_Z_NEW_YEAR_REWARD = "tb_z_new_year_reward",--春节活动表
    TB_Z_SHIELD_WORD = "tb_z_shield_word",--屏蔽字库
}

JsonConstant.__index = JsonConstant


--初始化jsonKey表 以classItem为生成的对像 返回一个list
function JsonConstant.GetItemListOfInitJson(jsonKey,classItem)
    local jsonTable = JsonManage:GetTableItemOfName(jsonKey)

    local jsonKey = jsonTable:GetJsonKey()
    --print("HeroSkillDictsys:InitData start[[[[[[[[[[[[[[[[[[")
    
    local jsonList = jsonTable:GetJsonTable()

    local list = {}

    for key, var in pairs(jsonList) do        
        local jsonItem = classItem.New()
         
        
        for fieldName,value in pairs(var) do
            jsonItem[fieldName] = value
        end


         
        --print(jsonItem:GetMessage()) 

        table.insert(list,jsonItem)
    end

    return list
end

--初始化jsonKey表 以classItem为生成的对像 并执行fun方法 来将数据放到system中 具体怎么放 由fun来定
-- fun的写法 如 FunctionDictionaryManage:AddFunctionItem（item)
function JsonConstant.InitJsonDataToSystem(jsonKey,classItem,fun)
    local jsonTable = JsonManage:GetTableItemOfName(jsonKey)

    local jsonKey = jsonTable:GetJsonKey()
    --print("HeroSkillDictsys:InitData start[[[[[[[[[[[[[[[[[[")
    
    local jsonList = jsonTable:GetJsonTable()

  

    for key, var in pairs(jsonList) do        
        local jsonItem = classItem.New()
         
        
        for fieldName,value in pairs(var) do
            jsonItem[fieldName] = value

            
        end


         
        --print(jsonItem:GetMessage()) 

        fun(jsonItem)
    end

    --移除原始数据
    JsonManage:RemoveTableOfName(jsonKey)
end

--return JsonConstant

--endregion



------------------------------------------------------
--                   JsonManage.lua
------------------------------------------------------
--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

JsonManage = 
{
	list = {}
}
-- JsonManage.__index = JsonManage
--newTable json表  key：表中以哪个字面为key值，name:表名
function JsonManage:PutData (newTable, key, name)
    newJsonItem = JsonItem:New()
    newJsonItem.jsonTable = newTable
    if key ~= nil then
        newJsonItem.jsonKey = key
    else
        newJsonItem.jsonKey = "json number" .. table.maxn (JsonManage.list)
    end
    if name ~= nil then
        newJsonItem.jsonName = name
    else
        newJsonItem.jsonName = "error table" .. table.maxn (JsonManage.list)
    end
    table.insert (self.list, newJsonItem)
    newJsonItem = nil
end

--获得参数表的数据  如果是生成类对像 可以调用 RemoveTableOfName 来移除原始数据
function JsonManage:GetTableItemOfName (jsonName)
    item = {}
    for key, var in pairs (self.list) do
        if var:GetJsonName () == jsonName then
            item = var
            return item
        end
    end
    logError("未找到json表 检查tb_z_json_system")
    logError(jsonName)
    logError("未找到json表"..jsonName)
    return item
end

--移除一个jsonTable 用于 常量数据用完后 
function JsonManage:RemoveTableOfName(jsonName)
     for key, var in pairs (self.list) do
        if var:GetJsonName () == jsonName then
            -- logError("移除表"..jsonName.."key为"..key)
            self.list[key]=nil
            break
        end
    end
end

--endregion

function JsonManage:Print()
    print("JsonManage:Print")
    print(#self.list)
    for k,v in pairs(self.list) do

        print(k,v.jsonKey)
    end
end


--return JsonManage
------------------------------------------------------
--                   LuaPrintTools.lua
------------------------------------------------------

LuaPrintTools = {}

--输出一个table 
function LuaPrintTools:PrintTable(theTable)
	print("print the table")
	if( type(theTable)~= "table") then
		print("not a table")
	end
	print(theTable)
	for k,v in pairs(theTable) do
		print(k,v)
	end
end


--返回是不是一个纯数字的table
function LuaPrintTools:IsArrayTable(t)  
    if type(t) ~= "table" then  
        return false  
    end  
  
    local n = #t  
    for i,v in pairs(t) do  
        if type(i) ~= "number" then  
            return false  
        end  
          
        if i > n then  
            return false  
        end   
    end  
  
    return true   
end  



--return LuaPrintTools
------------------------------------------------------
--                   UnityTools.lua
------------------------------------------------------
--BehaviourTools
UnityTools = {}


UnityTools.ComponentName_Sprite="UISprite"
UnityTools.ComponentName_Lbl="UILabel"
--横联花纹透明度
UnityTools.flowerAplhaVale = 120/255
UnityTools.PRINT_FLAG = false and true

UnityTools.farPosition = Vector3.New(10000,0,0)

--设置是否显示
function UnityTools.SetActive(object,yn)
	--暂时先不大改
	--UnityTools.SetActivityLogic(object,yn);

	
	if(object.gameObject ~=nil) then
		object.gameObject:SetActive(yn)
	else
		logError("设置Active时出错 不是gameObject")
		object.gameObject:SetActive(yn)
	end
	
	
end



--设置图片名字
function UnityTools.SetSpriteName(object,name)
	object.gameObject:GetComponent("UISprite").spriteName = name

	--print("setSpriteName")
	--print(name)

	local btn = object.gameObject:GetComponent("UIButton")
	if(btn~=nil) then
		
		btn.normalSprite=name;
		btn.hoverSprite=name;
		btn.pressedSprite=name;
	end
end

function UnityTools.SetSpriteAndButtonName(object,name)
	object.gameObject:GetComponent("UISprite").spriteName = name

	--print("setSpriteName")
	--print(name)

	local btn = object.gameObject:GetComponent("UIButton")
	if(btn~=nil) then
		
		btn.normalSprite=name;
		btn.hoverSprite=name;
		btn.pressedSprite=name;
	end
end

-- 随机数  传入 两个 int 值 进行随机
function UnityTools.RandomNum(a,b)
	local num = math.random(a,b)
	return num 
end 


--设置按钮是否有效  sprite如果为空 在btn查找 如果找不到不管 
function UnityTools.SetButtonEnable(go,yn,sprite)
	
	
	local btn = go:GetComponent("UIButton")
	if(sprite == nil) then
		sprite = btn.gameObject:GetComponent("UISprite")
	end
	btn.gameObject:GetComponent("BoxCollider").enabled=yn

	--以下一定要区分顺序 不然在enabled变为真时 会重置颜色
	if(yn) then
		UnityTools.ResetSpriteOfGary(sprite)
		btn.enabled=yn;
	else
		btn.enabled=yn;
		UnityTools.SetSpriteOfGary(sprite)
	end
	
	
end
--如果大于一万 就返回 一万为单位
function UnityTools.GetNumByW(nums,numType)
	local numsss = -1
	local tnum =  MathTools.tonumber(nums)
	
	if  numType ==  1  or numType == 2 then 
		--print("numTypenumTypenumTypenumTypenumType"..numType)
		if tnum <1000000 then 
		numsss = tnum
		else
			local cNum = tnum/10000
			--print("cNum........."..cNum)
			numsss = MathTools.GetPreciseDecimalActual(cNum,1).."万"
		end 
	else
		if tnum <10000 then 
		numsss = tnum
	   else
		local cNum = tnum/10000
		--print("cNum........."..cNum)
		numsss = MathTools.GetPreciseDecimalActual(cNum,1).."万"
		end 
		if tnum >10000000 then 
			local cNum = tnum/10000
			numsss = math.floor(cNum).."万"
		end 
	end 
	--print("nums"..nums)
	
	
--	print(numsss.."--------------------tnum"..tnum)
	return tostring(numsss)
end 



--设置深度
function UnityTools.SetDepth(go,depthValue)
	local widget = go:GetComponent("UIWidget")
	widget.depth = depthValue
end

--增加深度
function UnityTools.AddDepth(go,depthValue)
	local widget = go:GetComponent("UIWidget")
	widget.depth = widget.depth + depthValue
end

--增加在参数基础上深度
function UnityTools.AddDepthOfTarget(go,target,depthValue)
	local widget = go.transform:Find("redDotPre/Sprite"):GetComponent("UIWidget")
	local targetWidget = target:GetComponent("UIWidget")
	widget.depth = targetWidget.depth + depthValue
end
	

--设置控件是否有效
function UnityTools.SetCompentEnabled(component,yn)
	component.enabled = yn
end

--设置图片置灰 yn参数为假时 表示取消置灰
function UnityTools.SetSpriteOfGary(sprite,yn)
	if(yn==false) then
		sprite.color = Color.New(1,1,1);
	else
		sprite.color = Color.New(50/255,1,1);
	end

end

--设置图片置灰 yn参数为假时 表示取消置灰
function UnityTools.SetGameObjectOfGary(go,yn)
	local sprite = go:GetComponent("UISprite")
	if(yn==false) then
		sprite.color = Color.New(1,1,1);
	else
		sprite.color = Color.New(50/255,1,1);
	end

end



--取消图片置灰
function UnityTools.ResetSpriteOfGary(sprite)
	sprite.color = Color.New(1,1,1);

end

--设置label置灰 yn参数为假时 表示取消置灰
function UnityTools.SetUILabelOfGary(go,yn)
	local sprite = go:GetComponent("UILabel")
	if(yn==false) then
		sprite.color = Color.New(1,1,1);
	else
		sprite.color = Color.New(188/255,188/255,188/255);
	end
end


--以vector3 x z 为参数，获得vector2的距离
function UnityTools.GetDistanceOfV3(startP,endP)
	local v2s = Vector2.New(startP.x,startP.z)
	local v2e = Vector2.New(endP.x,endP.z)
	return Vector2.Distance(v2s,v2e)
end

--以vector3 x,y为参数，获得vector2的距离
function UnityTools.GetDistanceOfV3XY(startP,endP)
	local v3s = Vector3.New(startP.x,startP.y,0)
	local v3e = Vector3.New(endP.x,endP.y,0)
	return Vector3.Distance(v3s,v3e)
end


--以v2的方式（不看y值)lookat一个v3的坐标
function UnityTools.LootAtOfV3(go,targetV3)
	--local v3 = Vector3.New(targetV3.x ,targetV3.y, targetV3.z)

	local v3 = Vector3.New(targetV3.x ,targetV3.y,go.transform.position)
	--logError("看向坐标"..targetV3.x..";"..targetV3.y..";"..go.transform.position.z)
	--logError("原坐标"..go.transform.position.x..";"..go.transform.position.y..";"..go.transform.position.z)
	go.transform:LookAt(v3)
end

--当物体站在 start 时 向end 看 得到的角度 而不是现在的位置
function UnityTools.LootAtOfStartEndPosition(go,startP,endP)
	local oldP = go.transform.position;

	go.transform.position = startP;

	
	--logError("看向坐标"..targetV3.x..";"..targetV3.y..";"..go.transform.position.z)
	--logError("原坐标"..go.transform.position.x..";"..go.transform.position.y..";"..go.transform.position.z)
	go.transform:LookAt(endP)
	go.transform.position = oldP
end


--以v2的方式（不看y值)lookat一个v3的坐标
function UnityTools.LootAtOfV3Of2D(go,srcCityPosition,targetV3)

	local tempP = Vector3.New(srcCityPosition.x,srcCityPosition.y,srcCityPosition.z)
	


	local angleValue = UnityTools.GetAngleOfPosition(tempP,targetV3)

	
	--logError("UnityTools.LootAtOfV3Of2D看向坐标"..targetV3.x..";"..targetV3.y..";"..go.transform.position.z)
	--logError("UnityTools.LootAtOfV3Of2D原坐标"..srcCityPosition.x..";"..srcCityPosition.y..";"..srcCityPosition.z)
	local q = Quaternion.New()
	--logError("得到角度"..angleValue)
	q.eulerAngles = Vector3.New(0,0,angleValue);
	go.transform.localRotation = q
end


--获得两点的x与y距离
function UnityTools.GetPositionDiff(startP,endP)

	local p = Vector3.New()
	--默认认为startX小于endX  startX在左 end 在右
	local diffX = nil
	if(endP.x>startP.x) then
		diffX = (endP.x-startP.x)
	else
		diffX = -(startP.x-endP.x)
	end
	
	
	local diffY = nil
	if(endP.y>startP.y) then
		diffY = (endP.y-startP.y)
	else
		diffY = -(startP.y-endP.y)
	end

	p.x = diffX 
	p.y = diffY 
	p.z = endP.z
	return p
end

function UnityTools.GetAngleOfPosition(startP,endP)
 
	local tempP = startP;
	local targetV3 = endP;


	
	tempP = UnityTools.GetPositionDiff(startP,endP)

	if(UnityTools.PRINT_FLAG) then
		logError("原点"..tempP.x..";"..tempP.y)

		logError("目标点"..targetV3.x..";"..targetV3.y)
		logError("差值"..tempP.x..";"..tempP.y)
	end

	local tempCountP = Vector3.New(tempP.x,tempP.y,tempP.z)
	if(tempCountP.x<0) then tempCountP.x = 1-tempCountP.x end
	if(tempCountP.y<0) then tempCountP.y = 1-tempCountP.y end
	if(tempCountP.z<0) then tempCountP.z = 1-tempCountP.z end

	
	local value = (Mathf.Atan2(tempCountP.x,tempCountP.y));
	
	local finalValue =value * Mathf.Rad2Deg;

	if(UnityTools.PRINT_FLAG) then
		logError("得到坐标"..tempCountP.x..";"..tempCountP.y)
		logError("得到弧度"..value)
		logError("得到角度"..finalValue)
		logError("进行转换")
	end


	
	if(tempP.x>0) then
		if(tempP.y>0) then
			finalValue = -finalValue
		else --   x>0 y<0
			finalValue= 180+finalValue
		end

	else
		if(tempP.y>0) then
			finalValue= finalValue
		else-- x<0 y<0
			finalValue= 90 + 90 -finalValue
		end
	end
	return finalValue;

	
end



function UnityTools.Abs(value)
	if(value<0) then
		return -value
	end
	return value
end


-- 返回 是否 参数1 的绝对值大于参数2的绝对值
function UnityTools.IsAbsBig(value1,value2)
	return UnityTools.Abs(value1)>UnityTools.Abs(value2)
end


--获得 以p1为原点 p2为相对原点坐标的角度
function UnityTools.GetAngleOfPositionOfV2(p1,p2)
	local diffx = p2.x-p1.x
	local diffy = p2.y-p1.y
	
	return UnityTools.GetAngleOfValueOfV2(diffx,diffy)
end

--获得 以p1为原点 p2为相对原点坐标的角度
function UnityTools.GetAngleOfValueOfV2(diffx,diffy)

	local a = LuaToUnityLogicManage.Atan2(diffx,diffy)
	a = a*Mathf.Rad2Deg
	return a
end

--添加一个button事件 用于 有按下效果
function UnityTools.SetButton(go,fun,soundName)
	--print("设置按钮UnityTools.SetButton"..go.name)
	local btn = go:GetComponent("UIButton")
	if(btn==nil) then
		btn = go:AddComponent(typeof(UIButton))
	end

	local btnColorR=1;
	local btnColorG=1;
	local btnColorB=1;

	btn.duration=0.05

	--鼠标放入 不用管
	--btn.hover = Color.New(btnColorR,btnColorG,btnColorB)


	--鼠标按下
	btn.pressed = Color.New(0.5,0.5,0.5)
	--鼠标无效 当 btn.enabled=false 时   btn.SetState(UIButtonColor.State,true)设置成无效状态 但是可以点击
	btn.disabledColor = Color.New(btnColorR,btnColorG,btnColorB)


	if(fun~=nil) then

		local newFun = function() 
			fun(go)
			if(soundName == nil) then
				AudioManage.PlayDefaultButton()
			else
				if soundName ~= AudioManage.NOT_SOUND then
					AudioManage:Play(soundName)
				end
			end
		end
		UIEventListener.Get(go).onClick = newFun;
	end

end

--添加click事件
function UnityTools.SetClick(go,fun,soundName)
	--print("设置按钮UnityTools.SetClick"..go.name)
	if(fun~=nil) then
		--print("fun != nil")
		local newFun = function() 
			--print("newFun logic")
			fun(go)
			if(soundName == nil) then
				AudioManage.PlayDefaultButton()
			else
				if soundName ~= AudioManage.NOT_SOUND then
					AudioManage:Play(soundName)
				end
			end
			
		end
		UIEventListener.Get(go).onClick = newFun;
	end

end

function UnityTools.SetClickNotAudio(go,fun)
	--UIEventListener.Get(go).onClick=fun
	UnityTools.SetClick(go,fun,soundName)
end
function UnityTools.SetButtonNotAudio(go,fun)
	UIEventListener.Get(go).onClick=fun
	UnityTools.SetButton(go,fun,soundName)
end

--设置 uibutton控件是否可用
function UnityTools.SetUIButtonEnable(btn,yn)
	local uibutton = btn.gameObject:GetComponent("UIButton")
	if(uibutton~=nil) then
		uibutton.isEnabled=yn
	end
end


-- 保留小数点自定义位数 n不填就是只要整数
function UnityTools.GetPreciseDecimal(num, n)
	return MathTools.GetPreciseDecimal(num, n)
end
--设置transform转 x,y,z度
function UnityTools.TransformEulerAngles(tf , x,y,z)
	LuaToUnityLogicManage.setTransformEulerAngles(tf,x,y,z)
end

--切分字符串 delimiter 是用哪个字符进行切割	--本方法必须保证最后一位是分割符 否则会少一位
--notNil 为真时 如果传入字符为空 或是""时  返回{} 而不是nil
function UnityTools.split(str, delimiter,notNil)


	if str==nil or str=='' or delimiter==nil then
		if(notNil) then
			return {}
		else
			return nil
		end
	end
	
    local result = {}

	if(string.sub(str,-1) ~= delimiter) then
		--如果最后一位不是分隔符 添加一下分隔符
		str = str..delimiter
	end

    for match in (str):gmatch("(.-)"..delimiter) do
        table.insert(result, match)
    end
    return result
end

--分和字符串
function UnityTools.splitOfHadDelimiter(str, delimiter,notNil)
    --return string.split(str,delimiter);
--end
--function UnityTools.splitLogic(str, delimiter)
	if str==nil or str=='' or delimiter==nil then
		if(notNil) then
			return {}
		else
			return nil
		end
	end
	
    local result = {}
    for match in (str..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match)
    end
    return result
end
--设置物品品质框 物体 及 品质
function UnityTools.SetPropQuality(go,quality)
	local sp = go.gameObject.transform:GetComponent("UISprite")
	quality = quality +1
	sp.spriteName = EquipQuality[quality]
end 

--设置图片的宽高 或是label
function UnityTools.SetDimensions(sprite,width,height)
	sprite:SetDimensions(width,height)
end

--设置图片的宽高 或是label
function UnityTools.SetDimensionsW(sprite,width)
	sprite:SetDimensions(width,sprite.height)
end

--设置图片的宽高 或是label
function UnityTools.SetDimensionsH(sprite,height)
	sprite:SetDimensions(sprite.width,height)
end

--返回是否是enable的gameObject
function UnityTools.IsActive(go)
	return go.activeSelf
end
--生成蒙版
function UnityTools.AddMask(parentGo)
	local maskGo = Util.LoadPrefab("Prefab/mask")
	local mask = parentGo.transform:Find("mask")
	if mask == nil then 
		local go =  NGUITools.AddChild(parentGo, maskGo)
		go.name = "clickBg"
		go.transform.localPosition = Vector3.New(0,0,0)
	end 
end 
--销毁蒙版
function  UnityTools.DestroyMask(parentGo)
	local maskGo = parentGo.gameObject.transform:Find("maskPanel")
	if maskGo ~=  nil then 
		destroy(maskGo.gameObject)
	end 
end 
--字符替换
function UnityTools.StringReplace(str,oldSubStr,newSubStr)
	return string.gsub(str,oldSubStr,newSubStr)
end


function UnityTools.SetActivityLogicShow(gameObject)
	--gameObject.transform.localScale = Vector3.one
	UnityTools.SetActivityLogic(gameObject,true)
end
function UnityTools.SetActivityLogicHide(gameObject)
	--gameObject.transform.localScale = Vector3.zero
	UnityTools.SetActivityLogic(gameObject,false)
end

function UnityTools.SetActivityLogic(gameObject,yn)
	--print("调用UnityTools.SetActivityLogic"..gameObject.name)
	if(yn) then
		
		--gameObject.transform.localPosition = Vector3.zero
		gameObject.transform.localScale = Vector3.one
		
	else
		gameObject.transform.localScale = UIEffectTools.MIN_SCALE
		--gameObject.transform.localPosition = UnityTools.farPosition
	end
	--print("对"..gameObject.name.."进行缩放")
end

--重置坐标  用于主UI 显示
function UnityTools.ResetActivityOfOnlyPosition(gameObject)
	gameObject.transform.localPosition = Vector3.zero
end

--移动坐标 用于主UI隐藏时减少 drawcall  用于动画 
function UnityTools.HideActivityOfOnlyPosition(gameObject)
	gameObject.transform.localPosition = UnityTools.farPosition
end

--以设置坐标的方式显示隐藏界面
function UnityTools.SetActiveOnlyPosition(gameObject,yn)
	if yn then
		gameObject.transform.localPosition = Vector3.zero
	else
		gameObject.transform.localPosition = UnityTools.farPosition
	end
end
--物体是否显示状态 用positionX来判断
function UnityTools.IsActiveSelfOfPosition(gameObject)
	return gameObject.transform.localPosition == Vector3.zero
end
--物体是否是显示的状态 用缩放来判断
function UnityTools.IsActiveSelf(gameObject)
	return gameObject.transform.localScale == Vector3.one
end
--设置fontData默认id
function UnityTools.SetFontDataDefalutId(lbl,defalutId)
	lbl:GetComponent("FontData").defalutId = defalutId
end
--设置fontdata
function UnityTools.SetFontData(lbl,fontType,subType)
	lbl:GetComponent("FontData"):SetFont(fontType,subType)
end
--设置 按钮类 子样式
function UnityTools.SetFontDataOfButton(lbl,subType)
	lbl:GetComponent("FontData"):SetFont(FontConstant.BUTTON_TYPE,subType)
end

--设置确认按钮
function UnityTools.SetFontDataOfButtonSure(lbl)
	lbl:GetComponent("FontData"):SetFont(FontConstant.BUTTON_TYPE,FontConstant.BUTTON_BE_SURE)
end

--设置红色取消按钮
function UnityTools.SetFontDataOfButtonCancel(lbl)
	lbl:GetComponent("FontData"):SetFont(FontConstant.BUTTON_TYPE,FontConstant.BUTTON_CANCLE)
end

--设置 描述类子样式
function UnityTools.SetFontDataOfDesc(lbl,subType)
	lbl:GetComponent("FontData"):SetFont(FontConstant.DESC_TYPE,subType)
end

--设置 描述类子样式
function UnityTools.SetFontDataOfHeroName(lbl,quality)
	lbl:GetComponent("FontData"):SetFont(FontConstant.DESC_TYPE,FontConstant.DESC_HERO_NAME_1-1+quality)
end

--设置按钮文件是否有效 无效为灰态  yn为nil 时 默认为设置灰 yn有效时 如果为真 表示不灰 那么defaultType有值时 表示 设置的样子 如果无值  默认设为确认状态
function UnityTools.SetFontDataOfButtonLblEanble(lbl,yn,defaultType)
	if(yn == nil) then
		UnityTools.SetFontDataOfButton(lbl,FontConstant.BUTTON_GRAY)
	else
		if(yn) then
			if(defaultType==nil) then
				UnityTools.SetFontDataOfButton(lbl,FontConstant.BUTTON_BE_SURE)
			else
				UnityTools.SetFontDataOfButton(lbl,defaultType)
			end
		else
			UnityTools.SetFontDataOfButton(lbl,FontConstant.BUTTON_GRAY)
			
		end
	end
end

--设置按钮文件是否有效 无效为灰态  yn为nil 时 默认为设置灰 yn有效时 如果为真 表示不灰 那么defaultType有值时 表示 设置的样子 如果无值  默认设为确认状态
function UnityTools.SetFontDataOfButtonEanble(button,yn,defaultType)
	local lbl = button.transform:Find("Label")
	UnityTools.SetFontDataOfButtonLblEanble(lbl,yn,defaultType)
end


--设置品质 参数是物品常量 及 图片sprite
function UnityTools.SetGoodsQuality(goods,qualitySprite)
	if(goods == nil) then
		qualitySprite.gameObject:SetActive(false)
	elseif(goods:IsEquip()) then
		qualitySprite.gameObject:SetActive(true)
		qualitySprite.spriteName = EquipQuality[goods:GetQuality()+1]
	else
		qualitySprite.gameObject:SetActive(false)
	end

end

--设置小背景图（用于发现界面上小背景框丢失时使用）
function UnityTools.SetSmallBg(sprite,name)
	if (name ~= nil) then
		sprite.spriteName = name
	end
end

--設置碰撞體大小
function UnityTools.SetBoxCollider(boxCollider,size,offset)
	 if(boxCollider ~= nil) then
		local collider = boxCollider.transform:GetComponent("BoxCollider")
		collider.size = size
		collider.center = offset
	 end
end

--截取字符串
function UnityTools.SubStringUTF8(str, startIndex, endIndex)
    if startIndex < 0 then
        startIndex = UnityTools.SubStringGetTotalIndex(str) + startIndex + 1;
    end

    if endIndex ~= nil and endIndex < 0 then
        endIndex = UnityTools.SubStringGetTotalIndex(str) + endIndex + 1;
    end

    if endIndex == nil then 
        return string.sub(str, UnityTools.SubStringGetTrueIndex(str, startIndex));
    else
        return string.sub(str, UnityTools.SubStringGetTrueIndex(str, startIndex), UnityTools.SubStringGetTrueIndex(str, endIndex + 1) - 1);
    end
end

--获取中英混合UTF8字符串的真实字符数量
function UnityTools.SubStringGetTotalIndex(str)
    local curIndex = 0;
    local i = 1;
    local lastCount = 1;
    repeat 
        lastCount = UnityTools.SubStringGetByteCount(str, i)
        i = i + lastCount;
        curIndex = curIndex + 1;
    until(lastCount == 0);
    return curIndex - 1;
end

function UnityTools.SubStringGetTrueIndex(str, index)
    local curIndex = 0;
    local i = 1;
    local lastCount = 1;
    repeat 
        lastCount = UnityTools.SubStringGetByteCount(str, i)
        i = i + lastCount;
        curIndex = curIndex + 1;
    until(curIndex >= index);
    return i - lastCount;
end

--返回当前字符实际占用的字符数
function UnityTools.SubStringGetByteCount(str, index)
    local curByte = string.byte(str, index)
    local byteCount = 1;
    if curByte == nil then
        byteCount = 0
    elseif curByte > 0 and curByte <= 127 then
        byteCount = 1
    elseif curByte>=192 and curByte<=223 then
        byteCount = 2
    elseif curByte>=224 and curByte<=239 then
        byteCount = 3
    elseif curByte>=240 and curByte<=247 then
        byteCount = 4
    end
    return byteCount;
end
------------------------------------------------------
--                   LogFlag.lua
------------------------------------------------------
LogFlag={}

LogFlag.HeroLog=false


LogFlag.IS_TEST = true and false
------------------------------------------------------
--                   LuaTools.lua
------------------------------------------------------

LuaTools={}

--是不是数字
function LuaTools.IsNumber(value)
    if(value == nil) then
        return false
    end
    return type(value) == "number"
end


function LuaTools.Log(str)
    logWarn(str)
    
end


function LuaTools.ReplaceStr(src,findValue,replaceValue)
    --logError("字符串替换"..src..":"..findValue..":"..replaceValue)
    --gsub 方法返回两个参数 第一个是替换后的值  第二个是 替换了几次 加上个（） 就变成第一个值了
    local item = (string.gsub(src,findValue,replaceValue))
    --logError("替换后"..item..":"..src)
    return item
end


--获得首字母
function LuaTools.GetFirstString(str)
    --本逻辑 只可解决 英文字符 中文解决不了
    --return string.sub(str,0,1)
    --本逻辑可以解决中文字符
    for ch in string.gmatch(str,"[\\0-\127\194-\244][\128-\191]*") do 
		return ch 
	end 

    return "错误字符 原是"..str
end

--这里写一个排序方法 前提是必须支持orderIndex 从小到大
function LuaTools.Sort(theTable,order_param)
    
    table.sort(theTable,function(a,b) return a[order_param]<b[order_param] end)
    return theTable
end

--这里写一个排序方法 前提是必须支持orderIndex 从小到大
function LuaTools.SortOfNew(theTable,order_param)
    
    local newTable ={}
    for k,v in pairs(theTable) do
        table.insert(newTable,v)
    end
    table.sort(newTable,function(a,b) return a[order_param]<b[order_param] end)
    return newTable
end
--排序 从大到小(倒叙)
function LuaTools.SortDesc(theTable,order_param)
    
    table.sort(theTable,function(a,b) return a[order_param]>b[order_param] end)
end

--排序 从大到小 以参数方法返回 用于排序的值
function LuaTools.SortOfFunDesc(theTable,fun)
    local newTable ={}
    for k,v in pairs(theTable) do
        table.insert(newTable,v)
        --print("插入第"..k.."项")
    end
    --logError("以方法为参数排序"..#newTable.."个项")
    table.sort(newTable,function(a,b) return fun(a)>fun(b) end)
    return newTable
end

--排序 从小到大 以参数方法返回 用于排序的值
function LuaTools.SortOfFun(theTable,fun)
    local newTable ={}
    for k,v in pairs(theTable) do
        table.insert(newTable,v)
        print("插入第"..k.."项")
    end
    logError("以方法为参数排序"..#newTable.."个项")
    logError("fun==nil")
    logError(fun==nil)
    table.sort(newTable,function(a,b) return fun(a)<fun(b) end)
    return newTable
end

--获得一个复制品
function LuaTools.GetCopyOfTable(theTable)
    local list = {}
    for k,v in pairs( theTable ) do
        table.insert(list,v)
    end
    return list
end
--[[

table.sort(table, comp)

table.sort()函数对给定的table进行升序排序.

> tbl = {"alpha", "beta", "gamma", "delta"}
> table.sort(tbl)
> print(table.concat(tbl, ", "))
alpha, beta, delta, gamma

comp是一个可选的参数, 此参数是一个外部函数, 可以用来自定义sort函数的排序标准.

此函数应满足以下条件: 接受两个参数(依次为a, b), 并返回一个布尔型的值, 当a应该排在b前面时, 返回true, 反之返回false.

例如, 当我们需要降序排序时, 可以这样写:

> sortFunc = function(a, b) return b < a end
> table.sort(tbl, sortFunc)
> print(table.concat(tbl, ", "))
gamma, delta, beta, alpha

用类似的原理还可以写出更加复杂的排序函数. 例如, 有一个table存有工会三名成员的姓名及等级信息:

guild = {}

table.insert(guild, {
　name = "Cladhaire",
　class = "Rogue",
　level = 70,
})

table.insert(guild, {
　name = "Sagart",
　class = "Priest",
　level = 70,
})

table.insert(guild, {
　name = "Mallaithe",
　class = "Warlock",
　level = 40,
})


对这个table进行排序时, 应用以下的规则: 按等级升序排序, 在等级相同时, 按姓名升序排序.

可以写出这样的排序函数:

function sortLevelNameAsc(a, b)
　if a.level == b.level then
　　return a.name < b.name
　else
　　return a.level < b.level
　end
end

测试功能如下:

> table.sort(guild, sortLevelNameAsc)
> for idx, value in ipairs(guild) do print(idx, value.name) end
1, Mallaithe
2, Cladhaire
3, Sagart
]]

--在src中找所有findValue换成replaceValue


function LuaTools.TestReplaceString(src,a,b)
    print("LuaTools.TestReplaceString  param "..src..":"..a..":"..b..":")

    local str = string.gsub(src,a,b)
    print(" gsub logic")
    print(str)

    local s2 = LuaTools.aaaaa(src,a,b)
    print(s2)
end

function LuaTools.aaaaa(src,findValue,replaceValue)
    --return string.gsub(str,findValue,replaceValue)
    --return "aaaaa"
    --src  = "$C$C发生战斗"

    --findValue="$C$"
    --findValue="$C"
    --replaceValue="小沛"
    local str = (string.gsub(src,findValue,replaceValue))
    return str
end


--获得map形式的 元素个数
function LuaTools.GetMapSize(map)
    if(map == nil) then
        logError("LuaTools.GetMapSize map 不存在")
        return 0
    end
    local index = 0
    for k,v in pairs(map) do
        index = index+1
    end
    return index
end


--和到一个 非的 bool 值  要用not 关键字
function LuaTools.ChangeBool(yn)
    return not yn
end
------------------------------------------------------
--                   GUITools.lua
------------------------------------------------------

GUITools = {}


function GUITools.Awake(GameObject)

end

--获得文字的宽度
function GUITools.GetTextWidth(lbl)

		return lbl.width
	
end

--设置字体大小
function GUITools.SetFontSize(lbl,num)
    lbl.fontSize = num
end

function GUITools.Test(lbl)
    logError(GUITools.GetTextWidth(lbl))
end

function GUITools.TestSetText(text)
    BannerItem:SetTextLogic(text)
end
------------------------------------------------------
--                   FriendChatTools.lua
------------------------------------------------------
--聊天记录工具
FriendChatTools={}




--写文件
function FriendChatTools.WriteFile(path,fileName,text)
    print("写入文件"..path..":"..fileName..":"..text)
    ChatFileTools.writeFile(path,fileName,text)
end


--读文件
function FriendChatTools.ReadFile(path,fileName)
    local filepath = path..fileName
    print("filePath "..filepath)
    local item = ChatFileTools.readFileOfLuaTools(filepath)
    local strList = item.stringData
    print("共读取"..#strList.."行")
end



--读文件
function FriendChatTools.ReadFileOfStr(path,fileName)
    local filepath = path..fileName
    print("filePath "..filepath)
    local item = ChatFileTools.readFileOfLuaTools(filepath)
    local strList = item.stringData
    print("共读取"..#strList.."行")
end


--字节流读取文件
function FriendChatTools.ReadByte(path,filename)


    print("收到读取字节流");

    local bb = nil
    
    local finalPath = path..filename
    bb = ChatFileTools.ReadFileOfByteArray(finalPath)

    local str = bb:ReadString()
    print(str)
    str = bb:ReadString()
    print(str)
    str = bb:ReadString()
    print(str)
end

--字节流写入文件
function FriendChatTools.WriteByte(path,filename,text)

    print("收到写入字节流");
    local bb = ByteBuffer.New()
    bb:WriteString("给工工写")
    bb:WriteString("123123")
    bb:WriteString(text)
    ChatFileTools.WriteFileOfByteArray(path,filename,bb)
end

--根据参数内容 生成整体json体
function FriendChatTools.GetDataJsonStruct(text)
    local sb = StringBuffer.New()
    sb:Append("{");
    sb:Append("RECORDS\":[");

    sb:Append(text);

    sb:Append("]");
    sb:Append("}")

    return sb:GetMessageStrOfLastNotChangeLine()
end

--根据参数key,value生成json 格式的一行内容
function FriendChatTools.GetDataJsonLine(jsonItemList)
    --print("FriendChatTools.GetDataJsonLine")
    
    local sb = ""

    sb ="{\r\n";
    for i,v in ipairs(jsonItemList) do
        sb = sb..v
    end
    
    sb=sb.."},\r\n";
		
    

    return sb
end

--根据参数key,value生成json 格式的一行内容
function FriendChatTools.GetDataJsonItem(key,value)
    
    print("FriendChatTools.GetDataJsonItem")
    print(key)
    print(value);
    
    local str = "\""..key.."\":\""..value.."\","
    print(str)
    return str;
    
end
logError("初始化聊天记录工具")
