
LuaTools={}

--是不是数字
function LuaTools.IsNumber(value)
    if(value == nil) then
        return false
    end
    return type(value) == "number"
end

-- 一般用于输出  将一个bool 转成int
function LuaTools.GetNumOfBool(yn)
    if(yn) then
        return 1
    else
        return 0;
    end
end



function LuaTools.Log(str)
    logWarn(str)
    
end


function LuaTools.ReplaceStr(src,findValue,replaceValue)
    --logError("字符串替换"..src..":"..findValue..":"..replaceValue)
    --gsub 方法返回两个参数 第一个是替换后的值  第二个是 替换了几次 加上个（） 就变成第一个值了
    local item = (string.gsub(src,findValue,replaceValue))
    --logError("替换后"..item..":"..src)
    return item
end


--获得首字母
function LuaTools.GetFirstString(str)
    --本逻辑 只可解决 英文字符 中文解决不了
    --return string.sub(str,0,1)
    --本逻辑可以解决中文字符
    for ch in string.gmatch(str,"[\\0-\127\194-\244][\128-\191]*") do 
		return ch 
	end 

    return "错误字符 原是"..str
end

--这里写一个排序方法 前提是必须支持orderIndex 从小到大
function LuaTools.Sort(theTable,order_param)
    
    table.sort(theTable,function(a,b) return a[order_param]<b[order_param] end)
    return theTable
end

--这里写一个排序方法 前提是必须支持orderIndex 从小到大
function LuaTools.SortOfNew(theTable,order_param)
    
    local newTable ={}
    for k,v in pairs(theTable) do
        table.insert(newTable,v)
    end
    table.sort(newTable,function(a,b) return a[order_param]<b[order_param] end)
    return newTable
end
--排序 从大到小(倒叙)
function LuaTools.SortDesc(theTable,order_param)
    
    table.sort(theTable,function(a,b) return a[order_param]>b[order_param] end)
end

--排序 从大到小 以参数方法返回 用于排序的值
function LuaTools.SortOfFunDesc(theTable,fun)
    local newTable ={}
    for k,v in pairs(theTable) do
        table.insert(newTable,v)
        --print("插入第"..k.."项")
    end
    --logError("以方法为参数排序"..#newTable.."个项")
    table.sort(newTable,function(a,b) return fun(a)>fun(b) end)
    return newTable
end

--排序 从小到大 以参数方法返回 用于排序的值
function LuaTools.SortOfFun(theTable,fun)
    local newTable ={}
    for k,v in pairs(theTable) do
        table.insert(newTable,v)
        print("插入第"..k.."项")
    end
    logError("以方法为参数排序"..#newTable.."个项")
    logError("fun==nil")
    logError(fun==nil)
    table.sort(newTable,function(a,b) return fun(a)<fun(b) end)
    return newTable
end

--获得一个复制品
function LuaTools.GetCopyOfTable(theTable)
    local list = {}
    for k,v in pairs( theTable ) do
        table.insert(list,v)
    end
    return list
end
--[[

table.sort(table, comp)

table.sort()函数对给定的table进行升序排序.

> tbl = {"alpha", "beta", "gamma", "delta"}
> table.sort(tbl)
> print(table.concat(tbl, ", "))
alpha, beta, delta, gamma

comp是一个可选的参数, 此参数是一个外部函数, 可以用来自定义sort函数的排序标准.

此函数应满足以下条件: 接受两个参数(依次为a, b), 并返回一个布尔型的值, 当a应该排在b前面时, 返回true, 反之返回false.

例如, 当我们需要降序排序时, 可以这样写:

> sortFunc = function(a, b) return b < a end
> table.sort(tbl, sortFunc)
> print(table.concat(tbl, ", "))
gamma, delta, beta, alpha

用类似的原理还可以写出更加复杂的排序函数. 例如, 有一个table存有工会三名成员的姓名及等级信息:

guild = {}

table.insert(guild, {
　name = "Cladhaire",
　class = "Rogue",
　level = 70,
})

table.insert(guild, {
　name = "Sagart",
　class = "Priest",
　level = 70,
})

table.insert(guild, {
　name = "Mallaithe",
　class = "Warlock",
　level = 40,
})


对这个table进行排序时, 应用以下的规则: 按等级升序排序, 在等级相同时, 按姓名升序排序.

可以写出这样的排序函数:

function sortLevelNameAsc(a, b)
　if a.level == b.level then
　　return a.name < b.name
　else
　　return a.level < b.level
　end
end

测试功能如下:

> table.sort(guild, sortLevelNameAsc)
> for idx, value in ipairs(guild) do print(idx, value.name) end
1, Mallaithe
2, Cladhaire
3, Sagart
]]

--在src中找所有findValue换成replaceValue


function LuaTools.TestReplaceString(src,a,b)
    print("LuaTools.TestReplaceString  param "..src..":"..a..":"..b..":")

    local str = string.gsub(src,a,b)
    print(" gsub logic")
    print(str)

    local s2 = LuaTools.aaaaa(src,a,b)
    print(s2)
end

function LuaTools.aaaaa(src,findValue,replaceValue)
    --return string.gsub(str,findValue,replaceValue)
    --return "aaaaa"
    --src  = "$C$C发生战斗"

    --findValue="$C$"
    --findValue="$C"
    --replaceValue="小沛"
    local str = (string.gsub(src,findValue,replaceValue))
    return str
end


--获得map形式的 元素个数
function LuaTools.GetMapSize(map)
    if(map == nil) then
        logError("LuaTools.GetMapSize map 不存在")
        return 0
    end
    local index = 0
    for k,v in pairs(map) do
        index = index+1
    end
    return index
end


--和到一个 非的 bool 值  要用not 关键字
function LuaTools.ChangeBool(yn)
    return not yn
end


-- 将table 转成字符串 
function LuaTools.TableToString(theTable)
    return tools_Cjson.encode (theTable)
end

--将字符串转成table
function LuaTools.StringToTable(text)
    return tools_Cjson.decode (text)
end

function LuaTools.setPlayerPrefsOfString(key,value)
    UnityEngine.PlayerPrefs.SetString(key,value)
end

function LuaTools.getPlayerPrefs(key)
    UnityEngine.PlayerPrefs.GetString(key)
end

function LuaTools.getPlayerPrefsOfDefaultValue(key,value)
    UnityEngine.PlayerPrefs.GetString(key,value)
end