QualifyRewardDataItem={}
function QualifyRewardDataItem.New()
    local item = {}
    setmetatable(item,QualifyRewardDataItem)
    QualifyRewardDataItem.__index = QualifyRewardDataItem

    item.id = -1;    --档位ID
    item.needCount=-1   --档位完成需要个数
    item.isFinish=0     --是否完成
    item.type= -1;      --奖励类型  1 正常奖励 2  随机奖励
    item.rewardStr=-1;     --奖励字符串
    item.showType=-1;   --奖励显示类型 1-深蓝色小背景框，2-浅蓝色小背景框，3-大背景框
    --item.
    return item;
end
--返回奖励常量数据信息的字符串
function QualifyRewardDataItem:GetMessage()
    local str=string.format("   id:%d   needCount:%d   type:%d  ",self.id,self.needCount,self.type,self.type).."rewardStr:"..self.rewardStr.."showType"..self.showType;        
    return str;
end

QualifyRewardDataManager={}

QualifyRewardDataManager.curCount=-1    --当前个数
QualifyRewardDataManager.id = 2;--赛季奖励id  表里只有一个赛季奖励的数据
QualifyRewardDataManager.starttime=nil;--开始时间
QualifyRewardDataManager.endtime=nil;--结束时间
QualifyRewardDataManager.rewardDicDatas={};--当前所有的奖励物品信息


-- function QualifyRewardDataManager.InitJsonOfUnity()
--     QualifyRewardDataManager:InitJson()
--     logError("表中常量数据为".. QualifyRewardDataManager:GetMessage());
-- end
function QualifyRewardDataManager:InitJson()
    local rewardConfig = JsonManage:GetTableItemOfName (JsonConstant.TB_Z_QUALIFY_REWARD_CONFIG);
    local rewardGroup = JsonManage:GetTableItemOfName (JsonConstant.TB_Z_QUALIFY_REWARD_GROUP);
    local tableConfig = rewardConfig:GetJsonTable();--config表
    local tableGroup = rewardGroup:GetJsonTable();--group表
    --logError("tableConfig num "..#tableConfig);
    --logError("tableGroup num "..#tableGroup);                                                             --奖项id：需要达到的进度值,
    for k,configValue in pairs(tableConfig) do                  --先便利config表 找到对应赛季奖励的id项  然后根据他的rewardList字符串  找group表里对应id的奖项 
        if(configValue.id==self.id) then 
        logError("configValue.id === "..configValue.id.."self.id"..self.id)

            --logError("表中存在赛季奖励数据");
            self.starttime = configValue.starttime;
            self.endtime = configValue.endtime;
            local rewardList = configValue.rewardList;          --奖励字符串 奖励id：奖励需要到达的进度  间隔            
            rewardGroupStr = string.split(rewardList,",");            
            for k2,groupStrValue in pairs(rewardGroupStr) do       --groupStrValue 样式 为 1:10 ,  2:20  奖励id：奖励需要到达的进度 

                local dataTable=string.split(groupStrValue,":");           -- 将 1:10  拆分成 1  10  id  和需要到达的进度
                local rewardIdLocal = dataTable[1];
                local rewardNeedCount = dataTable[2];                     
                for k3,groupTableValue in pairs(tableGroup) do               --group 表
                    if(groupTableValue.rewardId==tonumber(rewardIdLocal)) then  --config表里str的id  如果和group表里的奖励id一样，说明有这个奖励
                        local item = QualifyRewardDataItem.New();
                        item.id=groupTableValue.rewardId;
                        item.rewardStr=groupTableValue.rewardStr;                        
                        item.type= groupTableValue.type;
                        item.showType = groupTableValue.showType;
                        item.needCount = tonumber(rewardNeedCount);
                        table.insert(self.rewardDicDatas,item);                                               
                    end
                end 
            end
        end
    end      
end
--获取常量信息，根据变量数据
function QualifyRewardDataManager:GetRewardDicDatas()
  --  print("==========================="..#self.rewardDicDatas.."/*/*/*/*/*/*/*/*/*/*/*/*/*")
    if(#self.rewardDicDatas==0) then
        self:InitJson();
        self:GetDicDatasByVar();
        return self.rewardDicDatas;
    end
    return self.rewardDicDatas;
end

--根据赛季奖励变量数据  返回需要显示的常量数据
function QualifyRewardDataManager:GetDicDatasByVar()
       local varList = QualifyRewardVarDataManager:GetRewardVarDatas();
       --logError("读取表中的数据个数为"..#self.rewardDicDatas.."varList====="..#varList);
       local needDicDatas = {};
       for k,varDataValue in pairs(varList) do
            for k,dicDataValue in pairs(self.rewardDicDatas) do
            --    logError(varDataValue.rewardId.." "..dicDataValue.id);
                -- --logError(varDataValue.rewardId==dicDataValue.id);
                if(tonumber(varDataValue.rewardId) == tonumber(dicDataValue.id)) then      
                  --  logError(varDataValue.rewardId.." "..dicDataValue.id);              
                    table.insert(needDicDatas,dicDataValue);                             
                    break;
                end
            end
       end       
       --logError("需要显示的个数"..#needDicDatas);  
       --排序
        table.sort(needDicDatas , function(a , b)
            return a.id < b.id 
        end)       
        self.rewardDicDatas = needDicDatas;
end
--返回所有奖励常量数据信息的字符串
function QualifyRewardDataManager:GetMessage()
    local str="";
    for k,dicDataValue in pairs(self.rewardDicDatas) do
        
        local message=str..dicDataValue:GetMessage();
        str = message;
    end        
    return str
end
--根据id获得对应的常量数据
function QualifyRewardDataManager:GetDicDataById(rewardId)
    for k,dataValue in pairs(self:GetRewardDicDatas()) do
        if(dataValue.id == rewardId)    then
            return dataValue;      
        end
    end
      return nil;
end
--获取下一个要到达进度的奖励以及他的索引
function QualifyRewardDataManager:GetNextReward()
    local curStarProcess = QualifyRewardVarDataManager:GetCurStarProcess();
    logError("curStarProcess===="..curStarProcess)
    local rewardDicDatas = self:GetRewardDicDatas();
    local length = #rewardDicDatas;
    logError("length====="..length)
    for k,dicDataValue in pairs(rewardDicDatas) do
        logError("dicDataValue.needCount==="..dicDataValue.needCount)
        if(dicDataValue.needCount >curStarProcess) then
            logError("下一个奖励为"..k);
            return dicDataValue,k;
        end
    end
    return rewardDicDatas[length],length;
end
--获得 下一个奖励的项
function QualifyRewardDataManager:GetNextRewardItem ()
    local curStarProcess = QualifyRewardVarDataManager:GetCurStarProcess();
    for k,dicDataValue in pairs(self:GetRewardDicDatas()) do        
             if(dicDataValue.needCount >curStarProcess) then 
                return  dicDataValue
             end
    end
    return nil 
end 
--获得当前奖励的项的星星数
function  QualifyRewardDataManager:GetCurOverRewardItemStars()
         local allStars  = 0;
         local curStarProcess = QualifyRewardVarDataManager:GetCurStarProcess();
         for k,dicDataValue in pairs(self:GetRewardDicDatas()) do        
             if(dicDataValue.needCount >curStarProcess) then 
                 if  k == 1  then
                   allStars = 0
                 else    
                    allStars =  self:GetRewardDicDatas()[k-1].needCount
                 end
                 return allStars
             end
          end
          return  allStars
end 
    -- body
--获取下一个要到达进度的奖励字符串
function QualifyRewardDataManager:GetNextRewardStr()


    local curStarProcess = QualifyRewardVarDataManager:GetCurStarProcess();
    for k,dicDataValue in pairs(self:GetRewardDicDatas()) do
        if(dicDataValue.needCount >curStarProcess) then
            return dicDataValue.rewardStr;
        end
    end
end 
