﻿QualifyRewardPanel=LuaBaseUI.New()
QualifyRewardPanel.go=nil;

function QualifyRewardPanel.Awake(obj)
    QualifyRewardPanel.go=obj;
    QualifyRewardPanel: InitEffectLogic();
    QualifyRewardPanel:InitData();
    QualifyRewardPanel:OpenUI();
end
function QualifyRewardPanel.Start()
    QualifyRewardPanel:SetSliderLength();
    QualifyRewardPanel:InitUi();
    QualifyRewardPanel:SetRewardPosition();
end
--优化物理大小
function QualifyRewardPanel:InitEffectLogic()
    local effectPre = Util.LoadPrefab("UIPanels/getRewardEffect")
    local effectGo  = NGUITools.AddChild(self.go, effectPre);      
    effectGo.name =    "getRewardEffect"

end 
function QualifyRewardPanel.OnDestroy()
    QualifyRewardPanel:CloseUI();
end

--初始化
function QualifyRewardPanel:InitData()     
    --奖励进度条
    self.progressBar = self.go.transform:Find("AllContain/Scroll View/progressBar"):GetComponent("UISlider");
    --奖励 根节点
    self.rewardsRoot = self.go.transform:Find("AllContain/Scroll View/rewards").gameObject;
    --标题
    self.title = self.go.transform:Find("AllContain/titleBg/Title"):GetComponent("UILabel");
    --当前是第几赛季
    self.curSeasonNum = QualifyRewardVarDataManager:GetCurSeasonNum();
    self.title.text = "S"..self.curSeasonNum..Lua_LanguageManager.GetContentOfID("qualify_reward_process_title");--赛季奖励
    --scrowView
    self.scrowView = self.go.transform:Find("AllContain/Scroll View").gameObject;
    --关闭按钮
    self.closeBtn = self.go.transform:Find("AllContain/closeButton").gameObject;
    local closeFunc = function ()  QualifyRewardPanel:CloseLogic()   end
    UIEventListener.Get(self.closeBtn).onClick = closeFunc;
    --scrowView初始局部坐标
    self.scrowViewBeginPos = self.scrowView.transform.localPosition;
    --奖项gameobject
    self.rewardObj = Util.LoadPrefab("UIPanels/qualifyRewardItem");    
    --奖励的y轴坐标
    self.posY=-33;
    --星星sprite的y轴坐标
    self.startPosY = -281;
    --进度条 头部相对于scrowview的位置坐标(进度条上面的图片)
    self.headPosX = self.progressBar.transform.localPosition.x+self.progressBar.transform:Find("Overlay").transform.localPosition.x;
    --奖励平均间距 (奖励间隔是固定的 不管实际值差多少)
    self.averageSpace=326;
    --奖励间隔 进度条的value值(间隔固定)
    self.averageValue=nil;
    --进度条图片
    self.sliderSprite = self.progressBar:GetComponent("UISprite");   
    --需要显示的奖励常量数据
    self.rewardDicList = QualifyRewardDataManager:GetRewardDicDatas();
    --奖励变量数据
    self.rewardVarList = QualifyRewardVarDataManager:GetRewardVarDatas();
    --当前累计星星数
    self.curStarProcess = QualifyRewardVarDataManager:GetCurStarProcess();
    --奖励ui  list
    self.rewardUiItemList = {};
    --下一个要到达的进度奖励物品ui 用来定位srollView
    self.nextReward=nil;
    --进度条总进度值  要大于最大奖励的进度值 
    self.sliderTotalValue=nil;
    --当前到达的进度点icon
    self.starIcon = self.go.transform:Find("AllContain/Scroll View/starBg").gameObject;
    --当前星星值显示label
    self.starNumLabel = self.starIcon.transform:Find("startNumLabel"):GetComponent("UILabel");
    self.starNumLabel.text = self.curStarProcess;
    --获得奖励特效界面
    self.getRewardEffect = self.go.transform:Find("getRewardEffect"):GetComponent("GetRewardEffect");
    local _nextReward,index = QualifyRewardDataManager:GetNextReward();
     --下一个要到达的进度奖励物品数据
    self.nextRewardData = _nextReward;
    --下一个要达到的奖励的索引
    self.nextRewardIndex = index;
    --赛季奖励下方提示文字
    self.tipsLabel = self.go.transform:Find("AllContain/titleBg/tipsLabel"):GetComponent("UILabel");
    self.tipsLabel.text = Lua_LanguageManager.GetContentOfID("qualify_reward_panel_tips");
    --跳转任务界面的按钮
    self.jumpToTaskBtn = self.go.transform:Find("AllContain/jumpToTaskBtn").gameObject;
    self.jumpToTaskBtn.transform:Find("Label"):GetComponent("UILabel").text = Lua_LanguageManager.GetContentOfID("check_task_list");
    UIEventListener.Get(self.jumpToTaskBtn).onClick =  function()
        --从赛季奖励点击 查看任务列表的事件
        GzTK.TKEvent(TalkingDataConst.TKE_CLICK_TASK_LIST_FROM_QUALIFY);
        QualifyRewardPanel:CloseLogic();        
        ViewLoginPanel.OpenTaskPanel();   
     end
    --logError("InitOver");
end


--赋值奖励变量数据
function QualifyRewardPanel:SetRewardsVarData(varData)
    self.rewardsVarData=varData;
end

--初始化 ui的显示
function QualifyRewardPanel:InitUi()
    --最大奖励需求值
    local maxRequire=self:GetRewardMaxRequire();
    --进度条总进度值  要大于最大的奖励值
    self.sliderTotalValue = maxRequire+tonumber(maxRequire/#(self.rewardDicList));
    self.curStarProcess = math.min(self.sliderTotalValue,self.curStarProcess);
    self.progressBar.value=self:GetCurProgressValue();
    --星星位置设置                                  上面图片的宽度需要-14   因为九宫切图切了5 所以要再加点
    local starX = self.headPosX +(math.min(self.progressBar.value,1) * (self.sliderSprite.width-14))+6;
    self.starIcon.transform.localPosition = Vector3.New(starX,self.startPosY,0);
    self:InitRewardUi();
end 

--根据奖励数量 设置slider的长度
function QualifyRewardPanel:SetSliderLength()
    local num = #(self.rewardDicList);
    --logError("当前需要显示的奖励个数为"..num);
    self.sliderSprite.width = (num+1)*self.averageSpace;
    self.averageValue = 1/(num+1);
end


--定位scrowView到某个奖励
function QualifyRewardPanel:SetRewardPosition()
      local target = self.nextReward.transform.localPosition;
      --局部坐标在scrowview初始中心点左边的 不需要定位
        if (target.x < 0) then
            return;
        end
        local panelWidth = self.scrowView:GetComponent("UIPanel").width;
        -- 最大可以移动的距离
        local maxX = self.headPosX+self.sliderSprite.width - panelWidth/2;
        local finalX = math.min(maxX, target.x);
        SpringPanel.Begin(self.scrowView, self.scrowViewBeginPos - Vector3.New(finalX, 0, 0), 10);
end 

--关闭面板逻辑
function QualifyRewardPanel:CloseLogic()   
    UIManager.PopUI();
    EventDispatcher.instance:InvokeEvent(EventNameList.eEventRefreshHomeGlodAndDiamond);
end

--获取当前奖励最大的星星值
function QualifyRewardPanel:GetRewardMaxRequire()
    local max=0;
    for k,dicDataValue in pairs(self.rewardDicList) do
        if(dicDataValue.needCount > max) then
            max = dicDataValue.needCount;
        end
    end
    return max;
end

--初始化奖励
function QualifyRewardPanel:InitRewardUi()
    for k,rewardDicValue in pairs(self.rewardDicList) do
        local haveReach = self.curStarProcess >= rewardDicValue.needCount;
        local rewardItem = NGUITools.AddChild(self.rewardsRoot, self.rewardObj);           
         if(haveReach==false and self.nextReward==nil) then         
                -- 设置 下一个将要达到的奖励
                self.nextReward = rewardItem;
            end
              --奖励ui的x位置                                                  上面图片的宽度需要-14 由于九宫切图 切了5 所以要再加个5
            local posX = self.headPosX + (math.min(k*self.averageValue,1)* (self.sliderSprite.width-14))+6;
            rewardItem.transform.localPosition = Vector3.New(posX, self.posY, 0);
            local rewardUiItem = QualifyRewardUiItem.New();
            table.insert(self.rewardUiItemList,rewardUiItem);
            rewardUiItem:SetData(rewardDicValue,QualifyRewardVarDataManager:GetVarDataByDic(rewardDicValue),self.curStarProcess,rewardItem);
            rewardUiItem:InitLogic();
    end
    if(self.nextReward == nil)  then
        local length=#self.rewardUiItemList
        self.nextReward = self.rewardUiItemList[length].go;
    end
end
--领取回调
function QualifyRewardPanel.ReceiveRewardCallBack(netData)  
    --logError("收到数据"..netData._data);
    UIManager.showLoading(false);
    if(netData) then
        if(netData._data)   then
            local dataStr = netData._data;
            --logError("收到的数据为"..dataStr);
            local dataList = tools_Cjson.decode (dataStr)
            if(dataList.code==0) then
                local data = dataList.data;
                if(data.code==1) then
                    local rewardId = data.rewardId;
                    local changeValue = data.changeValue;
                    local finalValue = data.finalValue;
                    local rewardValue= data.rewardValue;
                    --调c#里的处理领取奖励数据
                    PropVarDataManger.Instance:HandleReceiveReward(changeValue,finalValue);

                    if(QualifyRewardPanel:IsOpen()) then

                        local rewardItem = QualifyRewardPanel:GetRewardItemById(rewardId);
                        --设置为已领取
                        rewardItem:SetHaveReveive();      
                        --显示获取奖励特效
                        QualifyRewardPanel:ShowGetRewardEffect(rewardValue);

                        logError("收到协议时未关UI");
                    else
                        logError("收到协议时已经关UI了");
                    end
                    --如果头像框奖励不为空，说明有头像框奖励 要对头像框进行解锁
                    if(data.headList ~= nil) then
                        for k,borderValue in pairs(data.headList) do
                            --获得对应头像框
                            HeadBorderDataManager.GetNewBorder(borderValue.headId,borderValue.gettime,borderValue.expiretime);
                        end
                    end
                    --领取奖励成功发事件  赛季数+奖项id+需要达到的分数
                    GzTK.TKEventOfValue(TalkingDataConst.TKE_RECEIVE_QUALIFY_REWARD_SUCCESS,QualifyRewardPanel.GetReceiveRewardTKValue(rewardId));
                    --刷新主界面领取赛季奖励 提示宝箱的显示和隐藏
                    ViewLoginPanel.RefreshQualifyRewardBtnEffect();
                end         
            end
        end        
    end
end
--根据rewardid获取对应的rewarduiItem
function QualifyRewardPanel:GetRewardItemById(rewardId)
    for k,rewardItemValue in pairs(self.rewardUiItemList) do
        if(rewardItemValue:GetRewardId() == rewardId) then
            --logError("找到了对应的uiitem")
            return rewardItemValue;
        end
    end
end

--限时获取奖励特效
function QualifyRewardPanel:ShowGetRewardEffect(rewardStr)
    self.getRewardEffect:ShowGetRewardEffect(rewardStr);
end
--获得进度点的局部坐标
function QualifyRewardPanel:GetPointLocalPos(progressValue)
    local foreGroundWidget = self.sliderSprite:GetComponent("UIWidget");
    local corners = foreGroundWidget.localCorners;
    
end
--获得当前进度条的value 因为所有奖励要固定间隔 不能按实际的值算value
function QualifyRewardPanel:GetCurProgressValue()    
    if(self.curStarProcess > self.rewardDicList[#self.rewardDicList].needCount) then
        return 1;
    elseif(self.curStarProcess == self.rewardDicList[#self.rewardDicList].needCount) then
        return self.averageValue*#self.rewardDicList;
    else
        --已达奖励值得进度value
        local haveReachValue = (self.nextRewardIndex-1)*self.averageValue;    
        --上一个奖励的需要进度值
        local lastRewardNeedCount = nil;    
        if(self.nextRewardIndex==1) then
            lastRewardNeedCount = 0;
        else 
            logError("self.rewardDicList==="..#self.rewardDicList.."self.nextRewardIndex-1==="..(self.nextRewardIndex-1))
            logError(self.rewardDicList == nil)
            lastRewardNeedCount = self.rewardDicList[self.nextRewardIndex-1].needCount;
        end        
        --下一个奖励需要的进度值
        local nextNeedCount = self.rewardDicList[self.nextRewardIndex].needCount;
        --当前这个目标奖励阶段进度值
        local curPhaseNeedCount = nextNeedCount - lastRewardNeedCount;
        --当前实际进度条value = 已经达到进度的value+当前还未达到的 占比*平均间隔value
        local curValue = haveReachValue + (self.curStarProcess - lastRewardNeedCount)/curPhaseNeedCount*self.averageValue;        
        return curValue;
    end
end
--根据奖项id 获得对应的领取成功发送的事件参数 赛季数+奖项id+需要达到的分数
function QualifyRewardPanel.GetReceiveRewardTKValue(rewardId)
    local rewardDicData = QualifyRewardDataManager:GetDicDataById(rewardId);
    local needCount = "";
    if(rewardDicData ~= nil) then
        needCount = rewardDicData.needCount;
    end
    local str = "赛季：S"..QualifyRewardPanel.curSeasonNum.."   奖项id:"..rewardId.."   需要达到的分数："..needCount;
    return str;
end
