QualifyRewardUiItem={}

-- 新的效果逻辑 点击领取直接显示对号,等协议回来再显示特效
QualifyRewardUiItem.New_Effect_Logic = true
-- 测试用,保证每一个都是没点过的
QualifyRewardUiItem.test = false

function QualifyRewardUiItem.New()
    local item={};
    setmetatable(item,QualifyRewardUiItem);
    QualifyRewardUiItem.__index=QualifyRewardUiItem;
    --ui显示type  常量值
    item.COIN_BG_TYPE = 1;--深蓝色背景框
    item.NORMAL_BG_TYPE = 2;--浅蓝色背景框
    item.SPECIAL_BG_TYPE = 3;--橘黄色大背景框
    --奖励 root
    item.rewardRoot=nil
    --普通奖励bg
    item.normalRewardBg=nil;
    --特殊奖励bg
    item.specialRewardBg=nil;
    --金币奖励sprite
    item.coinSprite = nil;
    --皮肤sprite
    item.skinSprite = nil;
    --头像框sprite
    item.headBorderSprite = nil;
    --普通奖励sprite
    item.normalRewardSprite = nil;
    --奖励常量信息
    item.rewardDicData=nil;
    --奖励变量信息
    item.rewardVarData=nil;
    --当前累计星星个数
    item.curStarProcess=nil;
    --是否达到该奖励的进度
    item.haveReach=false;
    --是否已领取
    item.haveReceive=false;
    --当前奖励ui 的gameObject
    item.go=nil;
    --tween组件
    item.boxTweenScale=nil;
    --随机奖励宝箱描述bg
    item.descBg=nil;
    --随机奖励宝箱描述
    item.descLabel = nil;
    --需要达到的数值label
    item.needCountLabel=nil;
    --是否有未知的物品
    item.haveWeiZhi = false;      
    return item;
end

function QualifyRewardUiItem:InitLogic()
    self:Init();
    self:InitUi();
end

--初始化
function QualifyRewardUiItem:Init()    
    self.rewardRoot = self.go.transform:Find("rewardRoot");  
    --宝箱tween组件
    self.boxTweenScale = self.rewardRoot.gameObject:GetComponent("TweenScale");       
    self.descBg = self.go.transform:Find("rewardRoot/descBg").gameObject;
    --随机奖励宝箱描述
    self.descLabel = self.descBg.transform:Find("descLabel"):GetComponent("UILabel");
    self.normalRewardSprite = self.rewardRoot.transform:Find("normalSprite"):GetComponent("UISprite");
    self.headBorderSprite = self.rewardRoot.transform:Find("headBorderSprite"):GetComponent("UISprite");
    self.skinSprite = self.rewardRoot.transform:Find("skinSprite"):GetComponent("UISprite");
    self.coinSprite = self.rewardRoot.transform:Find("coinNormalSprite"):GetComponent("UISprite");
    self.specialRewardBg = self.rewardRoot.transform:Find("specialRewardBg"):GetComponent("UISprite");
    self.normalRewardBg = self.rewardRoot.transform:Find("normalRewardBg"):GetComponent("UISprite");  
    self.needCountLabel = self.go.transform:Find("numLabel"):GetComponent("UILabel");
    self.needCountLabel.text = ""..self.rewardDicData.needCount;   
    local clickFun = function() self:OnClick();end
    UIEventListener.Get(self.normalRewardBg.gameObject).onClick = clickFun;
    UIEventListener.Get(self.specialRewardBg.gameObject).onClick = clickFun;
    local tweenFun = function() self:PlayTween();end;
    UIEventListener.Get(self.descBg.gameObject).onClick = tweenFun;
end

--设置奖励常量和变量等相关数据
function QualifyRewardUiItem:SetData(dicData,varData,starProcess,obj)
    self.go=obj;
    self.rewardDicData = dicData;
    self.rewardVarData = varData;
    self.curStarProcess = starProcess;
    self.haveReach = self.curStarProcess >= self.rewardDicData.needCount;
    self.haveReceive = self.rewardVarData:IsHaveReceived();        
end

--初始化ui
function QualifyRewardUiItem:InitUi()
    self.specialRewardBg.gameObject:SetActive(self.rewardDicData.showType == self.SPECIAL_BG_TYPE);
    self.normalRewardBg.gameObject:SetActive(self.rewardDicData.showType ~= self.SPECIAL_BG_TYPE);
    local rewardStr = self.rewardDicData.rewardStr;          
    local data = nil
    local propId =-1;
    local propNum = 1;
    local rewardItem = nil;
    if(self.rewardDicData.type ~= 2) then --不是宝箱  就只有一个物品奖励 要显示这个奖励ui  如果是宝箱 就直接显示宝箱ui
         data = string.split(rewardStr,":");
         propId = tonumber(data[1]);
         propNum = tonumber(data[2]);
         rewardItem = PropDicDataManager.Instance:getPropDicItemOfKey(propId);
    end

--设置不同类型奖励的bg  和 对应的label    
    if(self.rewardDicData.showType == self.SPECIAL_BG_TYPE) then --是特殊奖励
        if(rewardItem.propType == Lua_ActivityConst.SKIN_ROLE_TYPE) then--是英雄
            self.specialRewardBg.transform:Find("Label"):GetComponent("UILabel").text=Lua_LanguageManager.GetContentOfID("skin_name_"..propId);
        elseif(rewardItem.propType == Lua_ActivityConst.HEAD_BORDER_PROP_TYPE) then--是头像框
            self.specialRewardBg.transform:Find("Label"):GetComponent("UILabel").text=Lua_LanguageManager.GetContentOfID("border_name_"..propId);
        elseif(rewardItem.propType == Lua_ActivityConst.WEI_ZHI_PROP_TYPE) then--是未知的物品
            self.haveWeiZhi = true;
            self.specialRewardBg.transform:Find("Label"):GetComponent("UILabel").text=Lua_LanguageManager.GetContentOfID("wei_zhi_prop");--未知物品
        else
            self.specialRewardBg.transform:Find("Label"):GetComponent("UILabel").text=Lua_LanguageManager.GetContentOfID("exchange_item_"..propId);
        end
        self.specialRewardBg.transform:Find("okSprite").gameObject:SetActive(self.haveReceive);
        if(QualifyRewardUiItem.test) then
            logError("测试的修改 这里一定要删")
            self.specialRewardBg.transform:Find("okSprite").gameObject:SetActive(false);
        
        end
    else--不是特殊奖励 
        if(self.rewardDicData.type == 2 ) then--是宝箱
            self.descLabel.text = self:GetBoxDescStr();
            self.normalRewardBg.transform:Find("Label"):GetComponent("UILabel").text = Lua_LanguageManager.GetContentOfID("qualify_reward_box_name");  
        elseif(rewardItem.propType == Lua_ActivityConst.WEI_ZHI_PROP_TYPE) then--是未知的物品
            self.haveWeiZhi = true; 
            self.normalRewardBg.transform:Find("Label"):GetComponent("UILabel").text=Lua_LanguageManager.GetContentOfID("wei_zhi_prop");--未知物品
        elseif(rewardItem.propType == Lua_ActivityConst.MONEY_PROP_TYPE) then   --是货币 只显示数量
            self.normalRewardBg.transform:Find("Label"):GetComponent("UILabel").text = ""..propNum;
        else--不是货币  正常奖励物品 显示数量+名字 如果数量不大于一 不显示数量
            local Num;
            if(propNum <= 1) then
                Num="";
            else
                Num=""..propNum;
            end
            self.normalRewardBg.transform:Find("Label"):GetComponent("UILabel").text = Num..Lua_LanguageManager.GetContentOfID("exchange_item_"..propId);  
        end      --非特殊奖励 label设置结束        
        --设置bg 非特殊奖励 用同一个节点 不同的图片
        self.normalRewardBg.transform:Find("okSprite").gameObject:SetActive(self.haveReceive);
        if(QualifyRewardUiItem.test) then
            logError("测试的修改 这里一定要删")
            self.normalRewardBg.transform:Find("okSprite").gameObject:SetActive(false);
        end
        if(self.rewardDicData.showType == self.NORMAL_BG_TYPE) then
            self.normalRewardBg.transform:GetComponent("UISprite").spriteName = "rewardBg2";
            self.normalRewardBg.transform:GetComponent("UIButton").normalSprite = "rewardBg2";
        else 
            self.normalRewardBg.transform:GetComponent("UISprite").spriteName = "rewardBg1";
            self.normalRewardBg.transform:GetComponent("UIButton").normalSprite = "rewardBg1";
        end
    end --bg和label设置结束

    --设置物品的sprite
    if(self.rewardDicData.type==2) then--宝箱
        self.normalRewardSprite.gameObject:SetActive(true);
        GzLoadAtlasManager.Instance:SetAtlasAndSprite(self.normalRewardSprite, "heroHead","box");	
        --宝箱大小单独调整
        self.normalRewardSprite.width = 160;
        self.normalRewardSprite.height = 155;	
        self.normalRewardSprite.transform.localPosition = self.normalRewardSprite.transform.localPosition + Vector3.New(0,5,0); 	        
    elseif(propId == 401) then--金币
        self.coinSprite.gameObject:SetActive(true);
    elseif(rewardItem.propType == Lua_ActivityConst.SKIN_ROLE_TYPE) then--英雄        
        self.skinSprite.gameObject:SetActive(true);
        self.skinSprite.spriteName = rewardItem.propSprite;
        self.skinSprite:MakePixelPerfect();
    elseif(rewardItem.propType == Lua_ActivityConst.HEAD_BORDER_PROP_TYPE) then--头像框 图集和图片需要根据表里的值设置 
        self.headBorderSprite.gameObject:SetActive(true);
        local borderData = HeadBorderDataManager:GetBorderDataById(rewardItem.propId);
        --设置头像框的图集和图片
        HeadBorderDataManager.SetSpriteByBorderId(self.headBorderSprite,borderData.headId)   
    else
        self.normalRewardSprite.gameObject:SetActive(true);
        GzLoadAtlasManager.Instance:SetAtlasAndSprite(self.normalRewardSprite, "heroHead",rewardItem.propSprite);        
    end
end
-----------
function QualifyRewardUiItem:OnClick()
    --logError("OnClick");
    --logError("needCount"..self.rewardDicData.needCount);
    if(self.haveReach)  then    --到达进度值
        if(self.haveReceive == false or self.test) then  --还没领取奖励
            if(self.haveWeiZhi) then --如果有未知物品 提示升级版本
                TipsManager.Instance:showTipOnce(LanguageManager.Instance:getLanguageByTID("email_reward_update_client"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))--请更新到最新客户端
            else
                self:ReceiveReward();
            end
        end
    else--没到达进度
    --logError("noreach");
    --没到到达进度
        if(self.rewardDicData.type==2) then        
            --是宝箱随机奖励 翻转ui显示描述
            self:PlayTween();
        else
            TipsManager.Instance:showTipOnce(Lua_LanguageManager.GetContentOfID("star_not_enough_to_get"), Vector3.New(0, UnityEngine.Screen.height / 10 * 2, 0))--星星不足目前无法领取奖励
        end
     end
end

--执行tween动画。
function QualifyRewardUiItem:PlayTween()
    if(self.rewardRoot.transform.localScale.x < 1 and self.rewardRoot.transform.localScale.x > 0 ) then
        return;
    end
    self.boxTweenScale.enabled = true;
    self.boxTweenScale.from = Vector3.New(1,1,1);
    self.boxTweenScale.to = Vector3.New(0,1,1);
    self.boxTweenScale:SetOnFinished(EventDelegate.Callback(function()
		self:FinishTween();
	end)
    );
    self.boxTweenScale:PlayForward();
end

--动画完成回调
function QualifyRewardUiItem:FinishTween()
    if(self.descBg.gameObject.activeSelf) then
        self.normalRewardBg.gameObject:SetActive(true);
        self.normalRewardSprite.gameObject:SetActive(true);
        self.descBg.gameObject:SetActive(false);                
    else        
        self.normalRewardBg.gameObject:SetActive(false);
        self.normalRewardSprite.gameObject:SetActive(false);
        self.descBg.gameObject:SetActive(true);
    end    
        -- self.boxTweenScale.from = Vector3.New(0,1,1);
        -- self.boxTweenScale.to = Vector3.New(1, 1, 1);
        -- self.boxTweenScale.enabled = true;
        self.boxTweenScale:ClearFinished();
        self.boxTweenScale:PlayReverse();    
end

--获得宝箱描述
function QualifyRewardUiItem:GetBoxDescStr()
    local str=Lua_LanguageManager.GetContentOfID("qualify_reward_box_desc");
    str = str.."\n";
    local rewardStrs = self.rewardDicData.rewardStr;
    local rewards = string.split(rewardStrs,",");
    for k,rewardValue in pairs(rewards) do
        local reward = string.split(rewardValue,":");
        local propId = reward[1];
        local propNum = reward[2];
        local rewardItem = PropDicDataManager.Instance:getPropDicItemOfKey(propId);
        if(rewardItem.propType == Lua_ActivityConst.SKIN_ROLE_TYPE) then--是英雄  propId就是英雄id
            str = str.."\n"..Lua_LanguageManager.GetContentOfID("skin_name_"..propId).."x"..propNum;
        elseif(rewardItem.propType == Lua_ActivityConst.HEAD_BORDER_PROP_TYPE) then --是头像框
            str = str.."\n"..Lua_LanguageManager.GetContentOfID("head_border_"..propId).."x"..propNum;
        elseif(rewardItem.propType == Lua_ActivityConst.WEI_ZHI_PROP_TYPE) then--是未知的物品
            self.haveWeiZhi = true;
            str = str.."\n"..Lua_LanguageManager.GetContentOfID("wei_zhi_prop").."x"..propNum;--未知物品
        else
            str = str.."\n"..Lua_LanguageManager.GetContentOfID("exchange_item_"..propId).."x"..propNum;
        end
    end
    return str;
end

--设置为已领取
function QualifyRewardUiItem:SetHaveReveive()
    --logError("SetHaveReveive");
    if(self.rewardDicData.showType == self.SPECIAL_BG_TYPE) then
        self.specialRewardBg.transform:Find("okSprite").gameObject:SetActive(true);
    else
        self.normalRewardBg.transform:Find("okSprite").gameObject:SetActive(true);
    end
    self.rewardVarData:SetHaveReaceive();
    self.haveReceive = true;
end

--领取奖励
function QualifyRewardUiItem:ReceiveReward()
    local taskType = NetConfig.HttpTaskType.HttpTaskType_Receive_Qualify_Reward
    local param = JsonObject.New();
    param:encode("rewardId",self.rewardDicData.id);
    local luaClass = "QualifyRewardPanel"
    local luaFun = "ReceiveRewardCallBack"
    

    if(QualifyRewardUiItem.New_Effect_Logic) then
        logError("测试的逻辑  这里不用删")
        self:SetHaveReveive()
    else
        UIManager.showLoading(true);
    end
    GzNet.Call(taskType,param,luaClass,luaFun)
end
--获取该奖励对应的id
function QualifyRewardUiItem:GetRewardId()
    return self.rewardDicData.id;
end
