QualifyRewardVarDataItem={}
function QualifyRewardVarDataItem.New()
    local item={};
    setmetatable(item,QualifyRewardVarDataItem);
    QualifyRewardVarDataItem.__index=QualifyRewardVarDataItem;
    item.rewardId=-1;
    item.rewardStatus=-1;
    --用来显示获得奖励特效的物品奖励string 
    item.rewardValue=-1;
    return item;
end
--设置为已领取
function QualifyRewardVarDataItem:SetHaveReaceive()
    self.rewardStatus = 1;
end
--奖励是否已经领取
function QualifyRewardVarDataItem:IsHaveReceived()
    if(self.rewardStatus == 1) then
        return true;
    else
        return false;
    end
end
function QualifyRewardVarDataItem:GetMessage()
    str=string.format("  rewardId=%d       rewardStatus=%d    ",self.rewardId,self.rewardStatus);
    return str;
end


QualifyRewardVarDataManager={}
--当前累计的星星数
QualifyRewardVarDataManager.starProcess=0;
--当前所有收到的奖励变量数据
QualifyRewardVarDataManager.rewardVarDatas={};
--当前是第几赛季
QualifyRewardVarDataManager.curSeasonNum = 1;
--存本地 每次第一次登陆 记录当天日期 具体到日 用来判断当天是不是第一次进游戏  只供发星星事件用
QualifyRewardVarDataManager.SEND_STAR_TK_LOGIN_FIRST = "SEND_STAR_TK_LOGIN_FIRST";


function QualifyRewardVarDataManager:GetRewardVarDatas()
    return self.rewardVarDatas;   
end

function QualifyRewardVarDataManager:GetMessage()
     local str="";
    for k,value in pairs(self.rewardVarDatas) do
        local message=str..value:GetMessage();
        str = message;
    end        
    return str
end

--根据常量信息获取对应的变量信息
function QualifyRewardVarDataManager:GetVarDataByDic(dicData)
    for k,varDataValue in pairs(self.rewardVarDatas) do
        if(varDataValue.rewardId == dicData.id) then
            return varDataValue;
        end
    end
    return nil;
end
--根据id获取对应的变量信息
function QualifyRewardVarDataManager:GetVarDataById(rewardId)
    for k,varDataValue in pairs(self.rewardVarDatas) do
        if(varDataValue.rewardId == rewardId) then
            return varDataValue;
        end
    end
    return nil;
end
--设置当前累计的星星数
function QualifyRewardVarDataManager:SetStarNum(num)
    self.starProcess = num;
    --刷新主界面 赛季奖励可领取提示 每次更新星星数 都要执行一下刷新
    ViewLoginPanel.RefreshQualifyRewardBtnEffect()    
end
--设置当前赛季
function QualifyRewardVarDataManager:SetSeasonNum(num)
    self.curSeasonNum = num;
end
--获取当前是第几赛季
function QualifyRewardVarDataManager:GetCurSeasonNum()
    return self.curSeasonNum;
end
--根据id获取对应的变量数据
function QualifyRewardVarDataManager:GetVarDataById(rewardId)
    for k,varDataValue in pairs(self.rewardVarDatas) do
        if(varDataValue.rewardId == rewardId)   then
            return varDataValue;
        end
    end
    return nil;
end
--获取当前的星星数
function QualifyRewardVarDataManager:GetCurStarProcess()
    return self.starProcess;
end
--从272协议获取奖励信息
function QualifyRewardVarDataManager:GetRewardDataByPro(rewardList)    
    --清空当前的奖励信息
    self.rewardVarDatas = {};
    for k,dataValue in pairs(rewardList) do
        local item = QualifyRewardVarDataItem.New();
        item.rewardId = dataValue.rewardId;
        item.rewardStatus = dataValue.status;
        item.rewardValue = dataValue.rewardValue;
        table.insert(self.rewardVarDatas,item);                
    end
    --刚进游戏 获取了星星数据之后 检测发送星星事件
    QualifyRewardVarDataManager.CheckAndSendStarTK()
    --logError("变量数据为==="..QualifyRewardVarDataManager:GetMessage());
end
--当前是否存在可领取的奖励
function QualifyRewardVarDataManager.HaveRewardCanReceive()
    if(QualifyRewardVarDataManager.rewardVarDatas ~= nil and #QualifyRewardVarDataManager.rewardVarDatas > 0) then
        for k,varValue in pairs(QualifyRewardVarDataManager.rewardVarDatas) do 
            if(QualifyRewardVarDataManager:IsCanReceiveRewardById(varValue.rewardId)) then
                return true;
            end
        end
        return false;
    else
        return false;
    end
end
--根据id 返回对应奖励是否可领取
function QualifyRewardVarDataManager:IsCanReceiveRewardById(rewardId)
    local varRewardData = self:GetVarDataById(rewardId);
    local dicRewardData = QualifyRewardDataManager:GetDicDataById(rewardId)
    if(varRewardData ~= nil and dicRewardData ~= nil) then
        --是否领取过
        local haveReceived = varRewardData:IsHaveReceived();
        --是否到达目标值
        local haveReachTarget = self.starProcess >= dicRewardData.needCount;
        return haveReceived == false and haveReachTarget == true;
    else
        return false;
    end
end
--检测是不是当天第一次登陆游戏，如果是当天第一次进游戏 就发送当前的星星事件 参数为星星值
function QualifyRewardVarDataManager.CheckAndSendStarTK()
    --如果当天是第一次登陆游戏
    if(TimeTools.getCurDayStrig() ~= UnityEngine.PlayerPrefs.GetString(QualifyRewardVarDataManager.SEND_STAR_TK_LOGIN_FIRST)
    and Lua_GzDebug.LOGIN_GAME_FIRST_TODAY) then
        --发送星星数值 事件
        GzTK.TKEventOfValue(TalkingDataConst.TKE_SEND_CUR_STAR_NUM,QualifyRewardVarDataManager.starProcess.."");
        --保存记录当天已经发送过
        UnityEngine.PlayerPrefs.SetString(QualifyRewardVarDataManager.SEND_STAR_TK_LOGIN_FIRST,TimeTools.getCurDayStrig());
    end 
end