﻿HeadBorderData = {};
function HeadBorderData.New()
    local item = {};
    setmetatable(item,HeadBorderData);
    HeadBorderData.__index = HeadBorderData;
    --头像框的id
    item.headId = -1;
    --头像框的种类    1：段位头像框，2：赛季奖励头像框，3：首冲获得头像框,4：周卡头像框，5：月卡头像框,6：其他
    item.typeClient = -1;
    --头像框相关值    赛季头像框为奖励段位，限时头像框为有效时间
    item.value = -1;
    --头像框所用的图集的名字
    item.atlasName = nil;
    --头像框所用的图片的名字
    item.spriteName = nil;
    --获得时间long
    item.getDate = -1;
    --结束时间long
    item.endDate = -1;
    --是不是新获得的
    item.isNew = false;
    return item;
end

-- function HeadBorderData:SetData(headDataList)
--     self.headId = headDataList.headId;
--     self.typeClient = headDataList.type;
--     self.value = headDataList.value;  
-- end
--头像框是否已解锁
function HeadBorderData:IsUnlocked()
    --0未解锁  1解锁
    local res = UnityEngine.PlayerPrefs.GetInt("headBorderLock"..self.headId,0) == 1;
    if(res) then
        --logError("头像已解锁"..self.headId);
    else
        --logError("头像未解锁"..self.headId);
    end

    return res;
end

--设置获得时间  时间需要存本地，因为服务器只会发解锁了的头像框数据，如果头像框到期，就收不到时间数据 这时候就得用本地存的时间数据。
function HeadBorderData:SetGetDate(longTime)
    if(longTime ~= nil) then
        self.getDate = longTime;
        UnityEngine.PlayerPrefs.SetString("headBorderGetDate"..self.headId,""..longTime);
    end    
end

--设置截止时间
function HeadBorderData:SetEndDate(longTime)
    if(longTime ~= nil) then
        self.endDate = longTime;
        --因为playerprefs不支持long  所以这里用string存
        UnityEngine.PlayerPrefs.SetString("headBorderEndDate"..self.headId,""..longTime);
    end
end

--获取获得时间string  2019.3.25这种形式
function HeadBorderData:GetGainDateStr()
    local timeLong = tonumber(UnityEngine.PlayerPrefs.GetString("headBorderGetDate"..self.headId,"0"))
    return GzTimeManage.Instance:GetTimeStrByServer(timeLong);
end

--获取截止时间 string 2019.3.25这种形式
function HeadBorderData:GetEndDateStr()
    local timeLong = tonumber(UnityEngine.PlayerPrefs.GetString("headBorderEndDate"..self.headId,"0"))
    return GzTimeManage.Instance:GetTimeStrByServer(timeLong);
end
--true 解锁  false  锁定
function HeadBorderData:SetUnlock(boolUnlock)
    if(boolUnlock) then
        UnityEngine.PlayerPrefs.SetInt("headBorderLock"..self.headId,1)
    else
        UnityEngine.PlayerPrefs.SetInt("headBorderLock"..self.headId,0)
    end    
end

function HeadBorderData:GetMessage()
    local str = "  headId:"..self.headId.."  typeClient:"..self.typeClient.."  value:"..self.value.."  atlasName:"..self.atlasName.."  spriteName:"..self.spriteName;
    return str;
end

--当前头像框是不是限时头像框 根据到期时间，本地如果存有到期时间 并且已解锁说明是限时中的头像框
function HeadBorderData:IsLimitTimeBorder()
    --本地记录的到期时间
    local endDateLong = tonumber(UnityEngine.PlayerPrefs.GetString("headBorderEndDate"..self.headId,"0"));
    local res =  endDateLong > 0 and self:IsUnlocked() ;    
    return res;
end

--当前头像框是不是永久头像框 如果本地没有存到期时间 而且存了获得时间 并且已解锁说明是永久的头像框
function HeadBorderData:IsPrBorder()
    local endDateLong = tonumber(UnityEngine.PlayerPrefs.GetString("headBorderEndDate"..self.headId,"0"));
    local getDateLong = tonumber(UnityEngine.PlayerPrefs.GetString("headBorderGetDate"..self.headId,"0"));
    local res =  endDateLong <= 0 and getDateLong > 0 and self:IsUnlocked() ;    
    return res;
end

--限时头像框是否到期
function HeadBorderData:IsOutOfDate()
    --已解锁
    if(self:IsUnlocked()) then
        --是限时头像框
        if(self:IsLimitTimeBorder()) then
            local outDateLong = tonumber(UnityEngine.PlayerPrefs.GetString("headBorderEndDate"..self.headId,"0"));            
            return GzTimeManage.Instance:haveOutOfDate(outDateLong);
        else
        --永久头像框
            return false;
        end
    else
    --未解锁
        return true;
    end
end
--设置 是否为新获得
function HeadBorderData:SetNew(_isNew)
    self.isNew = _isNew;
end
--返回 是否是新获得的头像框
function HeadBorderData:IsNewBorder()
    return self.isNew;
end