﻿HeadBorderDataManager = {};
--所有的头像框数据
HeadBorderDataManager.headBorderList = {};
--当前选择头像框存id本地的key
HeadBorderDataManager.borderSaveLocalKey = "curSelectBorderId";
--当前选择的头像框
HeadBorderDataManager.curBorderId = nil;
--没选头像框的情况下，默认的头像框id  服务器要的。
HeadBorderDataManager.DEFAULT_BORDER_ID = 2000;
--是否有首冲头像框资格（0：已有首冲头像框，1：充值领取首冲头像框）
HeadBorderDataManager.isFirstRechargeHead = 1;
--存本地 每次第一次登陆 记录当天日期 具体到日 用来判断当天是不是第一次进游戏  只供发头像个数事件用
HeadBorderDataManager.SEND_BORDER_NUM_TK_LOGIN_FIRST = "SEND_BORDER_NUM_TK_LOGIN_FIRST";
--有没有新获得的头像框(刷新红点用)
HeadBorderDataManager.haveNewBorder = false;

--获取当前选择的头像框id
function HeadBorderDataManager.GetCurBorderId()   
    --如果当前选择的id还没有值
    if(HeadBorderDataManager.curBorderId==nil) then
        --获取本地存储的当前头像框id 没有就返回0
        HeadBorderDataManager.curBorderId = UnityEngine.PlayerPrefs.GetInt(HeadBorderDataManager.borderSaveLocalKey,0);
    end    
    --为0说明还没有选择头像框
    if(HeadBorderDataManager.curBorderId == 0) then    
        return HeadBorderDataManager.DEFAULT_BORDER_ID;
    --当前选择的头像框是解锁状态
    elseif(HeadBorderDataManager:IsUnlocked(HeadBorderDataManager.curBorderId)) then    
        return HeadBorderDataManager.curBorderId;
    else
        UnityEngine.PlayerPrefs.DeleteKey(HeadBorderDataManager.borderSaveLocalKey);        
        return HeadBorderDataManager.DEFAULT_BORDER_ID;
    end
end

--设置当前选择头像框 返回是否成功
function HeadBorderDataManager:SetSelectBorder(id)
    --如果当前的头像框已解锁
    if(self:IsUnlocked(id)) then
        self.curBorderId = id;
        UnityEngine.PlayerPrefs.SetInt(self.borderSaveLocalKey,id);
        return true;
    else
        return false;
    end
end
--卸下头像框
function HeadBorderDataManager:UnloadCurBorder()
    UnityEngine.PlayerPrefs.DeleteKey(self.borderSaveLocalKey);
    self.curBorderId = nil;
end

--初始化头像框数据
function HeadBorderDataManager:InitJsonData()
    local jsonItem = JsonManage:GetTableItemOfName(JsonConstant.TB_Z_Head_BORDER);
    local jsonList = jsonItem:GetJsonTable();
    for k,dataValue in pairs(jsonList) do
        local item = HeadBorderData.New();
        item.headId = dataValue.headId;
        item.typeClient = dataValue.typeClient;
        item.value = dataValue.value;
        item.atlasName = dataValue.atlasName;
        item.spriteName = dataValue.spriteName;        
        table.insert(self.headBorderList,item); 
    end    
    --logError(self:GetMessage());
end


--获取当前所有头像框的信息
function HeadBorderDataManager:GetHeadBorderData()
    if(#self.headBorderList==0) then
        self:InitJsonData();
    end
        --刷新并重新锁定到期的头像框
        self:RefreshBorderEnd();
        return self.headBorderList;    
end

--通过id获取对应的头像框信息
function HeadBorderDataManager:GetBorderDataById(id)
    for k,borderData in pairs(self:GetHeadBorderData()) do
        if(borderData.headId == id) then
            return borderData;
        end
    end
    return nil;
end
--通过id判断头像框是否解锁
function HeadBorderDataManager:IsUnlocked(id)
    local res = UnityEngine.PlayerPrefs.GetInt("headBorderLock"..id,0) == 1;
    return res;
end


--测试解锁
function HeadBorderDataManager.TestUnlockBorder(id)
    HeadBorderDataManager:SetUnlockById(id,true)
end

--根据id设置头像框的解锁状态
function HeadBorderDataManager:SetUnlockById(id,boolUnlock)
    if(boolUnlock) then
        UnityEngine.PlayerPrefs.SetInt("headBorderLock"..id,1)
    else
        UnityEngine.PlayerPrefs.SetInt("headBorderLock"..id,0)
    end    
end
--清空所有解锁状态
function HeadBorderDataManager.ClearUnlock()
    for k, headValue in pairs(HeadBorderDataManager:GetHeadBorderData()) do
        UnityEngine.PlayerPrefs.DeleteKey("headBorderLock"..headValue.headId);
    end
end

function HeadBorderDataManager:GetMessage()
    local str = "所有头像框数据：";
    for k,headBorderValue in pairs(self.headBorderList) do
        str = str..headBorderValue:GetMessage();
    end
    return str;
end

--刷新头像信息 解锁了的限时头像框比对本地日期，看是否到期
function HeadBorderDataManager:RefreshBorderEnd()    
    if(#self.headBorderList > 0) then
        for k,borderValue in pairs(self.headBorderList) do
            --是限时头像框 且 已过期
            if(borderValue:IsLimitTimeBorder() and borderValue:IsOutOfDate()) then
                --如果到期的头像框是正在使用的 就需要卸掉头像框 重新刷新
                if(borderValue.headId == self.GetCurBorderId()) then 
                    HeadBorderDataManager:UnloadCurBorder();  
                    --刷新主界面头像框信息
                    ViewLoginPanel:RefreshCurBorerSprite();    
                end
                borderValue:SetUnlock(false);
            end
        end
    end    
end

function HeadBorderDataManager.Test()        
    HeadBorderDataManager.RechargeSuccessCallBack("common_weekly_card");
end
--处理首冲，周卡，月卡头像框 参数为充值回调里传过来的productId 从c#那边调过来;
--如果冲了周卡 月卡 或者满足了首冲 但是对应的头像框还没解锁  要发协议请求头像框(现在不发协议 直接解锁 由于不发协议 所以没有头像框相关的时间数据，需要重新登录才能看到头像框的获得时间和到期时间相关的数据)。
function HeadBorderDataManager.RechargeSuccessCallBack(productKey)    
    --需要请求解锁的头像框id
    local needUnlockId = "";
    --是否需要请求解锁头像框
    local needQuest = false;
    --如果买的是普通周卡
    if(productKey == ProductConst.COMMON_WEEKEND_CARD) then
        local weekendCardBorder = HeadBorderDataManager:GetBorderDataByType(HeadBorderConst.COMMON_WEEK_CARD_HEAD_BORDER);
        if(weekendCardBorder ~= nil) then
            for k,weekCardValue in pairs(weekendCardBorder) do
                --如果还没有解锁
                if(weekCardValue:IsUnlocked() == false) then
                    needUnlockId = needUnlockId..weekCardValue.headId..",";
                    needQuest= true;
                    HeadBorderDataManager.GetNewBorder(weekCardValue.headId);
                    logError("解锁普通周卡头像框")
                end
            end
        end
    end
    --如果买的是高级周卡
    if(productKey == ProductConst.SENIOR_WEEKEND_CARD) then
        local weekendCardBorder = HeadBorderDataManager:GetBorderDataByType(HeadBorderConst.SENIOR_WEEK_CARD_HEAD_BORDER);
        if(weekendCardBorder ~= nil) then
            for k,weekCardValue in pairs(weekendCardBorder) do
                --如果还没有解锁
                if(weekCardValue:IsUnlocked() == false) then
                    needUnlockId = needUnlockId..weekCardValue.headId..",";
                    needQuest= true;
                    HeadBorderDataManager.GetNewBorder(weekCardValue.headId);
                    logError("解锁高级周卡头像框")
                end
            end
        end
    end
    --除了1元和三元新手卡  都算是首冲
    if(productKey ~= ProductConst.NEW_PLAYER_CARD and productKey ~= ProductConst.YIYUAN_RECHARGE and productKey ~= ProductConst.FREE_DIAMOND_2 ) then
        local firstPayBorder = HeadBorderDataManager:GetBorderDataByType(HeadBorderConst.FIRST_PAY_HEAD_BORDER);
        if(firstPayBorder ~= nil) then
            for k,firstPayValue in pairs(firstPayBorder) do
                --如果还没有解锁
                if(firstPayValue:IsUnlocked() == false) then
                    needUnlockId = needUnlockId..firstPayValue.headId..",";
                    needQuest= true;
                    HeadBorderDataManager.GetNewBorder(firstPayValue.headId);
                    logError("解锁首冲头像框")
                end
            end
        end
    end
        --现在直接解锁，暂时不发协议
    if(needQuest) then
        --去掉最后的，
        -- local questStr = string.sub(needUnlockId,1,-2);
        -- logError("需要解锁的头像框为:"..questStr);
        -- 请求头像框协议
        --HeadBorderDataManager:QuestHeadBorder(questStr);
    end

end

--根据typeClient 获取头像框信息
function HeadBorderDataManager:GetBorderDataByType(borderType)
    local curBorders = self:GetHeadBorderData();
    local resBorders = {};
    for k,borderValue in pairs(curBorders) do
        if(borderValue.typeClient == borderType) then
            table.insert(resBorders,borderValue);
        end
    end
    return resBorders;
end

--领取头像框协议
function HeadBorderDataManager:QuestHeadBorder(idStr)    
    local taskType = NetConfig.HttpTaskType.HttpTaskType_Receive_Head_Border;
    local param = JsonObject.New();
    param:encode("headId",idStr);
    local luaClass = "HeadBorderDataManager"
    local luaFun = "QuestCallBack"
    GzNet.Call(taskType,param,luaClass,luaFun)
    UIManager.showLoading(true);

end
function HeadBorderDataManager.QuestCallBack(netData)    
    UIManager.showLoading(false);
    if(netData) then
        if(netData._data) then
            local callBackStr = netData._data;
            local callBackDatas = tools_Cjson.decode (callBackStr);
            if(callBackDatas.code == 0) then
                local headList = callBackDatas.data.headList;                
                for k ,headValue in pairs(headList) do 
                    HeadBorderDataManager:SetUnlockById(headValue.headId,true);
                    local borderData = HeadBorderDataManager:GetBorderDataById(headValue.headId);
                    if(borderData) then
                        borderData:SetGetDate(headValue.gettime);
                        --结束时间大于0 表示这个是限时头像框
                        if(headValue.expiretime > 0) then
                            borderData:SetEndDate(headValue.expiretime);
                        end
                    end
                end
                --change value todo
            end
        end
    end            
end
--从272协议获得头像框数据
function HeadBorderDataManager:GetBorderDataByPro(headList)       
    for k,dataValue in pairs(headList) do
        self:SetUnlockById(dataValue.headId,true);
        local borderData = self:GetBorderDataById(dataValue.headId);
        if(borderData) then
            borderData:SetGetDate(dataValue.gettime);
            --结束时间大于0 表示这个是限时头像框
            if(dataValue.expiretime > 0) then
                borderData:SetEndDate(dataValue.expiretime);
            end
        end       
    end
    --刚进游戏 成功收到了272的头像框数据 检测发送解锁头像框事件
    self.CheckAndSendBorderNumTk();        
end

--通过id获得对应头像框的atlas名字和sprite名字 供c#调用  
function HeadBorderDataManager.GetBorderSpriteMessageById(id)
    local borderData = HeadBorderDataManager:GetBorderDataById(id);
    --local str = str..borderData.atlasName..","..borderData.spriteName;    
    if(borderData) then
        return borderData.atlasName,borderData.spriteName;   
    else    
    --不存在的头像框
        return nil;
    end    
end
--获取当前拥有的头像框个数
function HeadBorderDataManager:GetHaveBorderNum()
    local headBorderDatas = self:GetHeadBorderData();
    local num = 0;
    for k,borderValue in pairs(headBorderDatas) do
        --如果已解锁
        if(borderValue:IsUnlocked()) then
            num = num+1;
        end
    end
    return num;
end
--是否已有首冲头像框
function HeadBorderDataManager:IsHaveFirstPayBorder()
    return self.isFirstRechargeHead == 0;
end
--获得头像框 参数都为数字
function HeadBorderDataManager.GetNewBorder(borderId,gettime,endtime)
    local borderData = HeadBorderDataManager:GetBorderDataById(borderId);
    --如果存在这个头像框
    if(borderData ~= nil) then
        --处理获得新的头像框事件
        HeadBorderDataManager.HandleGetNewBorderTK(borderData);
        borderData:SetUnlock(true);        
        if(gettime ~= nil) then
            borderData:SetGetDate(gettime);
        end
        if(endtime ~= nil) then
            borderData:SetEndDate(endtime);
        end
        --设置为新获得
        borderData:SetNew(true);
        HeadBorderDataManager.SetHaveNewBorder(true);
        --刷新主界面红点
        ViewLoginPanel.RefreshBorderRedDot()                
        --如果获得的是段位头像框并且现在佩戴的就是段位头像框  就直接替换(段位头像框只可能有一个  每个赛季会换 如果带着上个赛季的段位头像框，获得新段位头像框的时候 直接替换)
        if(borderData.typeClient == HeadBorderConst.GRADING_HEAD_BORDER) then
            --这里不用gecurborderid方法获取当前选择的头像框 是因为 获取新的段位头像框之前会把原来的段位头像框锁定，如果用gecurborderid方法获得当前选择的头像框id 他会先判断该头像框有没有解锁
            --没解锁 就返回一个不存在的id  所以我们直接读本地存的id  获取上一次带的是哪个头像框
            local curBorderId = UnityEngine.PlayerPrefs.GetInt(HeadBorderDataManager.borderSaveLocalKey,0);
            local curBorderData = HeadBorderDataManager:GetBorderDataById(curBorderId);
            --如果当前带的是段位头像框
            if(curBorderData ~= nil and curBorderData.typeClient == HeadBorderConst.GRADING_HEAD_BORDER) then 
                HeadBorderDataManager:SetSelectBorder(borderId);
                --刷新主界面头像框
                ViewLoginPanel:RefreshCurBorerSprite();
            end
        end
    end    
end


--锁定所有的赛季段位头像框，因为赛季头像框每个赛季根据段位给，而且赛季头像框没给截止时间，只给了获得时间，是按照永久头像框显示的，本地没法通过截止时间进行自行判断过期。
--所以在每个赛季结算获得赛季头像框的时候，要先把所有的赛季头像框锁定 再根据给的头像框解锁。
function HeadBorderDataManager.LockAllSeasonBorder()
    local borderDataList = HeadBorderDataManager:GetHeadBorderData();
    for k,borderValue in pairs(borderDataList) do
        --如果是段位头像框
        if(borderValue.typeClient == HeadBorderConst.GRADING_HEAD_BORDER) then
            borderValue:SetUnlock(false);
        end
    end
end
--传入uisprite和对应的头像框id 对头像框的图集和图片进行设置
function HeadBorderDataManager.SetSpriteByBorderId(uiSprite,borderId)
    GzLoadAtlasManager.Instance:SetSpriteByBorderId(uiSprite,borderId);
end
--刚进游戏 获取到头像框数据之后  检测是不是当天第一次登陆，并发送已解锁头像框个数的事件
function HeadBorderDataManager.CheckAndSendBorderNumTk()
    --如果当天是第一次进入游戏
    if(TimeTools.getCurDayStrig() ~= UnityEngine.PlayerPrefs.GetString(HeadBorderDataManager.SEND_BORDER_NUM_TK_LOGIN_FIRST)
    and Lua_GzDebug.LOGIN_GAME_FIRST_TODAY) then
        local unlockedBorderNum = HeadBorderDataManager:GetHaveBorderNum();
         --发送头像框个数 事件
        GzTK.TKEventOfValue(TalkingDataConst.TKE_SEND_CUR_BORDER_NUM,unlockedBorderNum.."");
         --保存记录当天已经发送过
        UnityEngine.PlayerPrefs.SetString(HeadBorderDataManager.SEND_BORDER_NUM_TK_LOGIN_FIRST,TimeTools.getCurDayStrig());
    end
end
--处理获得新的头像框事件 获得段位头像框不需要发送事件  参数为headBorderdata
function HeadBorderDataManager.HandleGetNewBorderTK(borderData)
    --如果头像框不是段位头像框
    if(borderData.typeClient ~= HeadBorderConst.GRADING_HEAD_BORDER) then 
        --发送获得头像框事件
        GzTK.TKEventOfValue(TalkingDataConst.TKE_GET_NEW_BORDER,borderData.headId.."");
    end
end
--设置 是否有新获得的头像框
function HeadBorderDataManager.SetHaveNewBorder(_haveNewBorder)
    HeadBorderDataManager.haveNewBorder = _haveNewBorder;
end
--返回  是否有新获得的头像框
function HeadBorderDataManager.IshaveNewBorder()
    return HeadBorderDataManager.haveNewBorder;
end