﻿SelectHeadBorderPanel = {};

function SelectHeadBorderPanel.Awake(obj)
    SelectHeadBorderPanel.go = obj;
    SelectHeadBorderPanel:Init();
    SelectHeadBorderPanel:SetHeadBorderData();
end

function SelectHeadBorderPanel.Start()
    SelectHeadBorderPanel:InitUi();
end

function SelectHeadBorderPanel.TestOpenPanel()   
    UIManager.CreateUIOfLua("SelectHeadBorderPanel");
end
--初始化变量数据
function SelectHeadBorderPanel:Init()
    --scrowView
    self.scrowView = self.go.transform:Find("Scroll View").gameObject;
    --已解锁icon
    self.haveUnlockIcon = self.scrowView.transform:Find("haveUnlock").gameObject;
    self.haveUnlockIcon.transform:Find("Label"):GetComponent("UILabel").text = Lua_LanguageManager.GetContentOfID("have_unlock");--已解锁
    --未解锁icon
    self.noUnlockIcon = self.scrowView.transform:Find("noUnlock").gameObject;
    self.noUnlockIcon.transform:Find("Label"):GetComponent("UILabel").text = Lua_LanguageManager.GetContentOfID("no_unlock");--未解锁
    --头像框一行多少个
    self.colNum = 4;
    --头像框父节点
    self.headBorderRoot = self.scrowView.transform:Find("headBorderRoot").gameObject;
    --已解锁y轴坐标 下面坐标都是局部坐标
    self.haveUnlockPosY = 249;
    --是否解锁的icon上边距离头像框的间距
    self.lockIconTopDis = 80;
    --是否解锁的icon下边距离头像框的间距
    self.lockIconBottomDis = 93;
    --第一个已解锁头像框的y轴坐标
    self.firstRowY = 156;
    --第一个头像框的x轴坐标 也是解锁未解锁的icon的x坐标
    self.firstRowX = -183;
    --每个头像框 x间距
    self.headBorderDisX = 122;
    --每个头像框 y间距
    self.headBorderDisY = 123;
    --已解锁头像框
    self.haveUnlockHeadBorder = {};
    --未解锁头像框
    self.noUnlockHeadBorer = {};
    --所有头像框 ui
    self.headBorderUiItems = {};
    --头像框预制体
    self.headBorderPrefab = Util.LoadPrefab("UIPanels/HeadBorder");
    --黑色背景
    self.blackBg = self.go.transform:Find("blackBg").gameObject;
    local closeFunc = function()  self:CloseLogic(); end;
    UIEventListener.Get(self.blackBg).onClick = closeFunc;
    --当前点击的头像框数据 用来在描述面板显示信息
    self.curClickBorderData = nil;
    --头像框描述面板
    self.borderDescPanel = self.go.transform:Find("borderDesc").gameObject;
    UIEventListener.Get(self.borderDescPanel).onClick = function()   self.borderDescPanel:SetActive(false); end;
    --头像框描述面板-主背景节点  也是会根据点击的头像移动的节点
    self.descMainBg = self.borderDescPanel.transform:Find("descMainBg").gameObject;
    --头像框描述面板-头像框图片
    self.headBorderSprite = self.descMainBg.transform:Find("headBorder"):GetComponent("UISprite");
    --头像框描述面板-头像框名字Label
    self.nameLabel = self.descMainBg.transform:Find("nameLabel"):GetComponent("UILabel");
    --头像框描述面板-头像框描述Label
    self.descLabel = self.descMainBg.transform:Find("descBg/descLabel"):GetComponent("UILabel");
    --头像框描述面板-头像框的获取时间Label
    self.timeLabel = self.descMainBg.transform:Find("timeLabel"):GetComponent("UILabel");
    --头像框描述面板-头像框选择按钮
    self.selectButton = self.descMainBg.transform:Find("selectButton"):GetComponent("UIButton");        
    --头像框描述面板-头像框选择按钮的Label
    self.selectButtonLabel = self.selectButton.transform:Find("Label"):GetComponent("UILabel");
    --头像框面板和点击的头像框之间的偏移量
    self.borderDescPanelOffset = Vector3.New(-88,-60,0);
end
--获取头像框信息 并分为已解锁和未解锁
function SelectHeadBorderPanel:SetHeadBorderData()
    local headBorderDatas = HeadBorderDataManager:GetHeadBorderData();
    for k,headBorderValue in pairs(headBorderDatas) do  
        --已解锁
        if(headBorderValue:IsUnlocked()) then
            table.insert(self.haveUnlockHeadBorder,headBorderValue);
        else
            table.insert(self.noUnlockHeadBorer,headBorderValue);
        end
    end
end
--初始化UI
function SelectHeadBorderPanel:InitUi()
    --计算好未解锁的icon的位置
    self:InitNoUnlockIcon();
    --初始化已解锁头像框
    self:InitHeadBorderPos(true);
    --初始化未解锁头像框
    self:InitHeadBorderPos(false);
end

--计算好未解锁icon的位置
function SelectHeadBorderPanel:InitNoUnlockIcon()
    --已解锁的头像占得行数
    local haveUnlockRow = 0;
    local haveUnlockNum = #self.haveUnlockHeadBorder;
    --logError("已解锁的头像框个数为"..haveUnlockNum);
    if(haveUnlockNum % self.colNum == 0) then
        haveUnlockRow = math.floor(haveUnlockNum / self.colNum);
    else
        haveUnlockRow = math.floor(haveUnlockNum / self.colNum + 1);
    end
    --未解锁icon Y坐标的值
    local posY = 0; 
    if(haveUnlockRow == 0) then
        posY = self.haveUnlockPosY - self.noUnlockIcon:GetComponent("UISprite").height*2;
    else
        posY = self.haveUnlockPosY - self.lockIconBottomDis - self.lockIconTopDis - self.headBorderDisY * math.max(haveUnlockRow-1,0);
    end    
    self.noUnlockIcon.transform.localPosition = Vector3.New(self.firstRowX,posY,0);
end
--计算并初始化 头像框位置 根据是否解锁 
function SelectHeadBorderPanel:InitHeadBorderPos(isUnlocked)
    --头像框  已解锁 或者未解锁的
    local headBorderList = {};
    --当前头像框里 第一个头像框y轴的位置
    local firstPosY = 0
    if(isUnlocked)  then
        headBorderList = self.haveUnlockHeadBorder;
        firstPosY = self.firstRowY;
    else
        headBorderList = self.noUnlockHeadBorer;
        firstPosY = self.noUnlockIcon.transform.localPosition.y - self.lockIconBottomDis;
    end
    --如果头像框数不为0
    if(#headBorderList ~= 0) then
        if(isUnlocked)  then
            --logError("当前初始化已解锁头像框");
        else
            --logError("当前初始化未解锁头像框");
        end
        
        for k,borderValue in pairs(headBorderList) do  
            local borderItem = NGUITools.AddChild(self.headBorderRoot,self.headBorderPrefab);
            borderItem.transform.localPosition = self:GetBorderPos(firstPosY,k);
            local item = HeadBorderUiItem.New(); 
            item:SetData(borderValue,borderItem);                      
        end
    end
end

--根据第一个头像框Y轴位置 和 头像框的索引值 算出头像框的位置
function SelectHeadBorderPanel:GetBorderPos(firstPosY,index)
    --所在行数
    local row = 0;
    if(index % self.colNum == 0) then
        row = math.floor(index/self.colNum);
    else
        row = math.floor(index/self.colNum + 1);
    end
    --算出y坐标
    local posY = firstPosY - (row - 1) * self.headBorderDisY;
    --所在列数
    local col = 0;
        if(index % self.colNum == 0) then
        col = self.colNum;
    else
        col = index % self.colNum;
    end
    --算出x坐标
    local posX = self.firstRowX + (col-1) * self.headBorderDisX;
    return Vector3.New(posX,posY,0);
end

--关闭面板逻辑
function SelectHeadBorderPanel:CloseLogic()
    UIManager.PopUI();
end

--刷新头像框描述面板 参数为头像数据 和点击的这个头像的局部坐标 用来决定描述面板的位置
function SelectHeadBorderPanel:RefreshBorderDescPanel(borderData,clickBorderLocalPos)
    self.curClickBorderData = borderData;
    --是否解锁
    local haveUnlocked = self.curClickBorderData:IsUnlocked();
    HeadBorderDataManager.SetSpriteByBorderId(self.headBorderSprite,self.curClickBorderData.headId);    
    --如果是已解锁头像框
    if(haveUnlocked) then
         --设置选择按钮的状态
         --如果当前头像框已选择 
        if(self:IsCurClickSelected()) then            
            self.selectButtonLabel.text = Lua_LanguageManager.GetContentOfID("unload");--卸下
            self.selectButton.transform:GetComponent("UISprite").spriteName = "orangeButton";
            self.selectButton.normalSprite = "orangeButton";
            self.selectButton.transform:GetComponent("BoxCollider").enabled = true;
            UIEventListener.Get(self.selectButton.gameObject).onClick = function () self.UnloadCurBorder() end;
        else
            --头像框不是当前已选择
            self.selectButton.transform:GetComponent("UISprite").spriteName = "orangeButton";
            self.selectButton.normalSprite = "orangeButton";
            self.selectButtonLabel.text = Lua_LanguageManager.GetContentOfID("button_select");--选择
            self.selectButton.transform:GetComponent("BoxCollider").enabled = true;
            UIEventListener.Get(self.selectButton.gameObject).onClick = function () self:ClickSelectBorderBtn() end;
        end 
         --设置时间label的字样                    
          self.timeLabel.gameObject:SetActive(true); 
          --如果是段位头像框 就显示固定字样，如下赛季收回
        if(self.curClickBorderData.typeClient == HeadBorderConst.GRADING_HEAD_BORDER) then
            self.timeLabel.text = Lua_LanguageManager.GetContentOfID("grading_border_timeDesc");
        --如果是限时头像框          
        elseif(self.curClickBorderData:IsLimitTimeBorder()) then
            --到期时间
            self.timeLabel.text = Lua_LanguageManager.GetContentOfID("end_time")..self.curClickBorderData:GetEndDateStr();
        elseif(self.curClickBorderData:IsPrBorder()) then
            --logError("时间str === "..self.curClickBorderData:GetGainDateStr());
            --获得时间
            self.timeLabel.text = Lua_LanguageManager.GetContentOfID("get_time")..self.curClickBorderData:GetGainDateStr();
        else
            self.timeLabel.gameObject:SetActive(false); 
        end        
    else
        --头像框未解锁
        self.selectButton.transform:GetComponent("UISprite").spriteName = "grayButton";
        self.selectButton.normalSprite = "grayButton";
        self.selectButtonLabel.text = Lua_LanguageManager.GetContentOfID("skin_not_get");--未拥有
        self.selectButton.transform:GetComponent("BoxCollider").enabled = false;
        self.timeLabel.gameObject:SetActive(false);
    end
    --设置头像框名字和描述
    self.nameLabel.text = Lua_LanguageManager.GetContentOfID("border_name_"..self.curClickBorderData.headId);
    self.descLabel.text = Lua_LanguageManager.GetContentOfID("border_desc_"..self.curClickBorderData.headId);
    self.borderDescPanel.gameObject:SetActive(true);
    --设定的borderDescPanelOffset偏移值 是在scroll没有滑动的情况下 设定出来的。
    --因为在滑动scrollview 的时候， 头像框这些具体的子物体会跟着移动。但是实际panel是往相反的方向偏移的 所以在我们眼中 只有子物体在动，panel没动，
    --在scrollView有偏移的情况下，我们获取到的头像框的坐标并不是能实际拿来计算的坐标  要先减去偏移值，才能用来计算
    self.descMainBg.transform.localPosition = clickBorderLocalPos -Vector3.New(0,self.scrowView:GetComponent("UIPanel").clipOffset.y,0)  + self.borderDescPanelOffset;
end

--点击选择头像框按钮
function SelectHeadBorderPanel:ClickSelectBorderBtn()
    --如果点击的头像框数据不为空
    if(self.curClickBorderData) then
        local borderId = self.curClickBorderData.headId;    
        if(HeadBorderDataManager:SetSelectBorder(borderId)) then
            --选择成功
            self.borderDescPanel:SetActive(false);
            ViewLoginPanel:RefreshCurBorerSprite();
            --logError("选择头像框成功"..borderId);
            --todo
        else
            --logError("选择头像框失败"..borderId);
            --选择失败
            --暂无处理
        end
    end
end
--卸下当前选择的头像框
function SelectHeadBorderPanel.UnloadCurBorder()
    HeadBorderDataManager:UnloadCurBorder();  
    --刷新主界面头像框信息
    ViewLoginPanel:RefreshCurBorerSprite();    
    SelectHeadBorderPanel.borderDescPanel:SetActive(false);
end
--当前点击的头像框是否是已选择的
function SelectHeadBorderPanel:IsCurClickSelected()
     if(self.curClickBorderData) then
        local borderId = self.curClickBorderData.headId;
        return borderId == HeadBorderDataManager.GetCurBorderId();
     end
end


