--促销商店管理
PromotionItemSystem = {}

--所有物品项
PromotionItemSystem.allItems = {}
--宝箱价格
PromotionItemSystem.costBoxItem = 0

--商店打印开关
PromotionItemSystem.LOG_PROMOTION_PANEL = false

--宝箱领取物品类型
PromotionItemSystem.BOX_ITEM_TYPE = 2
--限时免费物品类型
PromotionItemSystem.AD_ITEM_TYPE = 3
--每日精选物品类型
PromotionItemSystem.DAY_ITEM_TYPE = 4
--背包选出的限时特惠物品
PromotionItemSystem.DISCOUNT_ITEM_TYPE = 5

--物品未购买状态
PromotionItemSystem.PROMOTION_ITEM_UNSOLD = 0
--物品已购买状态
PromotionItemSystem.PROMOTION_ITEM_SOLD = 1
--钻石id
PromotionItemSystem.COST_GEM_PROPID = 402
--金币id
PromotionItemSystem.COST_GOLD_PROPID = 401


--获得物品名称
function PromotionItemSystem:GetItemNameById(propId)
    local propItem = PropDicDataManager.Instance:getPropDicItemOfKey(propId)
    local nameStr = nil
    if propItem ~= nil then
        if propItem.propType == 8 then 
            -- nameStr = PetDataDicSystem.GetPetNameByPieceId(propId)
            nameStr = LanguageManager.Instance:getLanguageByTID(PetDataDicSystem.GetPetNameByPieceId(tonumber(propId)))
        elseif propItem.propType == 6 then
            nameStr = LanguageManager.Instance:getLanguageByTID("skin_name_" .. tostring(propId))
        elseif propItem.propType ==9 then
            nameStr = LanguageManager.Instance:getLanguageByTID(PetDataDicSystem.GetPetNameOfPetId(propId))
        else
            nameStr = LanguageManager.Instance:getLanguageByTID("exchange_item_" .. tostring(propId))
        end
    end
    return nameStr
end

--根据type 和 index 获得物品项
function PromotionItemSystem.GetItemByTypeIndex(type,index)
    local targetItem = nil
    for k,v in pairs(PromotionItemSystem.allItems) do
        if (type == v.type) and (index == v.index) then
            targetItem = v
        end
    end
    return targetItem
end     

--由costPropId 获得 cost 的icon
function PromotionItemSystem:GetCostSpriteById(propId)
    local costSprite = "gem"
    if propId == PromotionItemSystem.COST_GOLD_PROPID then
        costSprite = "coin"
    elseif propId == PromotionItemSystem.COST_GEM_PROPID then
        costSprite = "gem"
    end
    return costSprite
end
--处理物品购买后的逻辑
function PromotionItemSystem:OnItemPurchased(type , index)
    if type ==PromotionItemSystem.BOX_ITEM_TYPE then
        if PromotionItemSystem.LOG_PROMOTION_PANEL then
            logError("宝箱物品没有购买限制,,,不会显示sold out")
        end 
        PromotionPanel:OnGetBoxReward()
    else
        for k,v in pairs(PromotionItemSystem.allItems)do
            if (type == v.type) and (index == v.index) then
                v.status = PromotionItemSystem.PROMOTION_ITEM_SOLD
            end
        end
    end
end

--获得类型倒计时
function PromotionItemSystem:GetTypeCountDownTime(type)
    local time = 0
    for k,v in pairs(PromotionItemSystem.allItems) do
        if v.type == type then
            time = v.refreshCountdown
        end
    end
    return time
end
--加入物品想
function PromotionItemSystem:PutBoxItem()
    local prItem = PromotionItemData.New()
    prItem.id = 2001
    prItem.type = PromotionItemSystem.BOX_ITEM_TYPE
    prItem.index = 1
    prItem.propId = 1
    prItem.propNum = 1
    prItem.cost = 50
    prItem.costPropId = 402
    prItem.status = PromotionItemSystem.PROMOTION_ITEM_UNSOLD
    prItem.refreshCountdown = 0
    prItem.beforeCost = 0
    table.insert(PromotionItemSystem.allItems,prItem)
end