﻿--任务常量项
QuestTaskDicItem = {}

function QuestTaskDicItem.New()
    local item = {}
    setmetatable(item, QuestTaskDicItem)
    QuestTaskDicItem.__index = QuestTaskDicItem
    -- 任务Id
    item.questId = 0
    --任务类型
    item.type = 0
    --任务的目标进度值
    item.require = 0
    --任务的描述
    item.dec = ""
    --特殊值1(用于额外需求的值,如特定英雄参与战斗的skinId,特定模式匹配的pairType)
    item.value = ""
    --任务的星际
    item.star = 0

    return item
end 

--获得key
function QuestTaskDicItem :GetKey()
    return  self. questId
end 
--获得任务的星星的数量
function QuestTaskDicItem:GetStar()
    return self.star
end 
-- 获得任务的类型
function QuestTaskDicItem:GetTaskType()
    return self.type
end 
--获得任务的描述
function QuestTaskDicItem:GetTaskDec()
    return  self.dec
end 


function QuestTaskDicItem:GetShowText()


    local taskText = Lua_LanguageManager.GetContentOfID( self.dec)
    --print("taskText is " .. taskText);      --使用魔法师在排位模式中进行2场比赛


    local newTargetStr = self:GetNewTargetStr(self.type);
    return StringTools.Replace(taskText,newTargetStr)

    
end

function QuestTaskDicItem:GetNewTargetStr()

    -- #表示  字段值 #v表示value中的第几个值 #R表示 require字段
    local target="#V1,#V2,#R"

    local workID = "";
    local gameType = "";

    local newTargetStr=""

    local workName=""
    local gameTypeName=""
    if(self.type == 5) then --职业  和游戏类型 和个数
        
        local tempParamValue = string.split(self.value.."","_")
        workID = tempParamValue[1]
        gameType = tempParamValue[2]


        --print("职业"..workID.."游戏类型"..gameType.."次数是"..self.require)

        workName = LanguageManager.Instance:getLanguageByTID("skin_name_"..workID)
        gameTypeName = LanguageManager.Instance:getLanguageByTID(StringTools.gameTypeKey[gameType]);
        --print("职业是"..workName)
        --print("游戏模式为"..gameType)

        newTargetStr = "#V1="..workName..",#V2="..gameTypeName..",#R="..self.require;
    elseif (self.type == 2) then    --只用游戏类型 和个数
        
        workID = self.value
        workName = LanguageManager.Instance:getLanguageByTID("skin_name_"..workID)
        newTargetStr = "#V1="..workName..",#R="..self.require;
    else    --只有个数
        newTargetStr = "#R="..self.require
    end
    
    
    
    --print("targetStr"..newTargetStr);
    return newTargetStr;
end

