
Lua_LanguageManager={}

Lua_LanguageManager.content = {}

print(UnityEngine.SystemLanguage.ChineseSimplified)
--print(SystemLanguage.ChineseSimplified)
Lua_LanguageManager.languageList = {
    UnityEngine.SystemLanguage.ChineseSimplified,
    UnityEngine.SystemLanguage.English,
    UnityEngine.SystemLanguage.Portuguese,
    UnityEngine.SystemLanguage.Spanish,
    UnityEngine.SystemLanguage.Russian,
    UnityEngine.SystemLanguage.ChineseTraditional,
    UnityEngine.SystemLanguage.Japanese,
    UnityEngine.SystemLanguage.Korean,
}
function Lua_LanguageManager.InitData()

    local jsonTable = JsonManage:GetTableItemOfName(JsonConstant.TB_LANGUAGE_LUA)
    local jsonKey = jsonTable:GetJsonKey()
	local jsonList = jsonTable:GetJsonTable()
	for key, var in pairs(jsonList) do       
		local jsonItem = LanguageItem:New()
		jsonItem.key = var.多语言TID
        jsonItem.content[UnityEngine.SystemLanguage.ChineseSimplified] = var.简体中文
        jsonItem.content[UnityEngine.SystemLanguage.English] = var.英文
        jsonItem.content[UnityEngine.SystemLanguage.Portuguese] = var.巴西
        jsonItem.content[UnityEngine.SystemLanguage.Spanish] = var.西班牙
        jsonItem.content[UnityEngine.SystemLanguage.Russian] = var.俄语
        jsonItem.content[UnityEngine.SystemLanguage.ChineseTraditional] = var.繁体中文
        jsonItem.content[UnityEngine.SystemLanguage.Japanese] = var.日语
        jsonItem.content[UnityEngine.SystemLanguage.Korean] = var.韩语
        -- self:PutItemData(key,jsonItem)
      --  logError(jsonItem:GetMessage());
        Lua_LanguageManager.content[jsonItem.key] = jsonItem;
    end 
end

function Lua_LanguageManager.GetCurLanguage()
    return GzChannel.getCurLanguage()
end

-- 返回指定的多语言 如果是unity调用 需要在c#端加一个[0]才可以获得字符串
function Lua_LanguageManager.GetContentOfID(id)
    --logError("LanguageManager.GetContentOfID"..id)
    local str = "无数据";
    local item = nil
    item = Lua_LanguageManager.content[id]
    if(item == nil) then
        str = "不存在的多语言id" .. id
        --找不到就从c#的txt多语言表里找
        str = LanguageManager.Instance:getLanguageByTIDLua(id);
        --print("ID不存在")
    else
        str = item.content[Lua_LanguageManager.GetCurLanguage()]
        --print('当前语言为')
        --print(LanguageManager.GetCurLanguage())
        --print(str)
    end
    return str
end
--供unity调用 用来找lua用的json多语言表 为了两边互相兼容
function Lua_LanguageManager.GetContentOfIDByUnity(id)
    --logError("LanguageManager.GetContentOfID"..id)
    local str = "无数据";
    local item = nil
    item = Lua_LanguageManager.content[id]
    if(item == nil) then
        str = "不存在的多语言id" .. id
        --print("ID不存在")
    else
        str = item.content[Lua_LanguageManager.GetCurLanguage()]
        --print('当前语言为')
        --print(LanguageManager.GetCurLanguage())
        --print(str)
    end
    return str
end

LanguageItem={}

function LanguageItem.New()
    local item = {}
    setmetatable(item,LanguageItem)
    LanguageItem.__index = LanguageItem;
    
    item.key = nil--ID值
    item.content = {} --多语言内容

    return item
end

function LanguageItem:GetMessage()
    local sb =  StringBuffer.New();
    sb:append("key " .. self.key);
    for i , v in ipairs(Lua_LanguageManager.languageList) do
        if(self.content[v] == nil) then
            sb:append("语言"..i.."内容".."为空");
        else
            
      --      print(self.content[v])
            sb:append("语言"..i.."内容"..self.content[v]);
        end
    end
    return sb:getMessage()
end


--LanguageManager.InitData()